from BeautifulSoup import BeautifulSoup as parser
import httplib, mimetypes, urlparse, urllib
from time import sleep
from random import random




def getAlignment(windowList):
	seqstring = ""
	for i in range(len(windowList)):
		seqstring += ">" + str(i) + "\r\n" + windowList[i] + "\r\n"
		
	url = "http://blocks.fhcrc.org/blocks-bin/makeblocks.pl"
	urlparts = urlparse.urlsplit(url)
	
	#Define the contents of each 
	ad = 	("address", 	"")
	desc = 	("desc", 		"")
	seq = 	("sequences", 	seqstring)
	f = 	("seqfile", 	"", "")
	
	result = post_multipart(urlparts[1], urlparts[2], [ad, desc, seq], [f])
	resulturl = "http://" + urlparts[1] + parser(result).a.attrs[0][1]
	
		
	#Fetch and parse resultfile
	content = urllib.urlopen(resulturl).read()

	resultpage = parser(content)
	summary = resultpage.pre.string.strip()
	
	token = "width = "
	table = summary[summary.find(token)+len(token):].split("\n")
	
	for line in table:
		print line
	
	motiflength = int(table.pop(0))

	if len(table) != len(windowList):
		print "Error: input- and result-table not of same length"
		return None

	r = range(len(windowList))
	for line in table:
		index, i, mot = line.split()
		
		#BLOCKS assigns the first letter index 1. Thus...
		i = int(i)-1
		
		#Not sure if index is always 0 if segment is aligned far towards the right, or if it can be negative.
		#So just to be sure...
		if i < 0:
			i = 0
			while mot[0] == "X":
				mot = mot[1:]
				i -= 1
		r[int(index)] = i
		
	return motiflength, r

#functions from Python cookbook:

def posturl(url, fields, files):
	return post_multipart(urlparts[1], urlparts[2], fields, files)

def post_multipart(host, selector, fields, files):
	content_type, body = encode_multipart_formdata(fields, files)
	h = httplib.HTTPConnection(host)  
	headers = {
		'User-Agent': 'User-Agent: Mozilla/5.0 (Windows;U; Windows NT 5.1; en-US; rv:1.8.0.1) Gecko/20060111 Firefox/1.5.0.1',
		'Referer': 'http://blocks.fhcrc.org/blocks/make_blocks.html',
		'Content-Type': content_type
		}
	h.request('POST', selector, body, headers)
	
	#wait for a while to make sure data have been processed
	seconds = 3 + (random()*2)
	print "Waiting", seconds, "seconds to make sure data have been processed"
	sleep(seconds)
	
	
	res = h.getresponse()
	return res.read()  

def encode_multipart_formdata(fields, files):
	"""
	fields is a sequence of (name, value) elements for regular form fields.
	files is a sequence of (name, filename, value) elements for data to be uploaded as files
	Return (content_type, body) ready for httplib.HTTP instance
	"""
	BOUNDARY = '----------216312375127631'
	CRLF = '\r\n'
	L = []
	for (key, value) in fields:
		L.append('--' + BOUNDARY)
		L.append('Content-Disposition: form-data; name="%s"' % key)
		L.append('')
		L.append(value)
	for (key, filename, value) in files:
		L.append('--' + BOUNDARY)
		L.append('Content-Disposition: form-data; name="%s"; filename="%s"' % (key, filename))
		L.append('Content-Type: %s' % get_content_type(filename))
		L.append('')
		L.append(value)
	L.append('--' + BOUNDARY + '--')
	L.append('')
	body = CRLF.join(L)
	content_type = 'multipart/form-data; boundary=%s' % BOUNDARY
	return content_type, body

def get_content_type(filename):
	return mimetypes.guess_type(filename)[0] or 'application/octet-stream'

if __name__ == '__main__':
	import main
	main.main()
