#Constants in the database

DBNAME = "results.db"

#dataset_source
CREBTYPE			= 1
MOTIFSEARCHTYPE 	= 2
TOMPATYPE			= 3
TRANSFACTYPE		= 4
SYNTYPE				= 5

#dataset_type
KNOWN_MOTIFS		= 1
MOTIF_WINDOWS		= 2
UNKNOWN_MOTIFS		= 3

#pattern_type
HDISTID = "hdi"
IUPACID = "reg"
PWMID = "pwm"
PBMID = "pbm"
OPTIMALID = "opt"


PTYPES = [HDISTID, IUPACID, PWMID, OPTIMALID]

PTYPESNAMES = {HDISTID:"Hamming distance", IUPACID:"IUPAC string", PWMID:"PWM", OPTIMALID:"Optimal"}


COLORS = ['#0000aa', '#ffff66', '#cc00cc', '#66ccff']

COLORMAPPING = dict(zip(PTYPES, COLORS))

#Training type
BASIC = "basic"
BLOCKS = "blocks"
RAP = "randap"
RAA = "randaa"
CVBASIC = "cvbasic"
CVBLOCKS = "cvblocks"
CALIGN = "centalign"



DATASET_SOURCE = {	CREBTYPE: ("Nested MICA", "Taken from Nested MICA, a motif-finder program from Thomas Down and Tim Hubbard: http://www.sanger.ac.uk/Software/analysis/nmica/"),\
					MOTIFSEARCHTYPE: ("Motif Search", "Taken from the 'Motif Search'-program found on http://compbio.cs.princeton.edu/bindsites/ . Contains real DNA-binding sites."),\
					TOMPATYPE: ("Tompa", "Taken from the 'Motif Search'-program found on http://compbio.cs.princeton.edu/bindsites/ . Contains real DNA-binding sites."),\
					TRANSFACTYPE: ("Transfac", "Taken directly from the transfac database"),
					SYNTYPE: ("Synthetic", "100% synthetic datasets")}


DATASET_TYPE = {	KNOWN_MOTIFS: "Known motifs",\
					MOTIF_WINDOWS: "Motif windows",\
					UNKNOWN_MOTIFS: "Motifs unkown"}



