#This is a simple wrapper for the library dataset module.
#Some additional database values are applied to the datasets here
import Ini
Ini.versionInit()

from dataset.dna.tompa05assesing.real.read import getDataset as _getRealTompa
from dataset.dna.tompa05assesing.real.read import SETS as REALTOMPASETS
from dataset.dna.tompa05assesing.mchain.read import getDataset as _getMchainTompa
from dataset.dna.tompa05assesing.mchain.read import SETS as MCHAINTOMPASETS
from dataset.dna.tompa05assesing.generic.read import getDataset as _getGenericTompa
from dataset.dna.tompa05assesing.generic.read import SETS as GENERICTOMPASETS
from dataset.dna.synthetic.x_mutations.read import getDataset as _getSynXMut
from dataset.dna.synthetic.x_mutations.read import SETS as SXMSETS
from dataset.dna.synthetic.four_mutations.oops.read import getDataset as _getSynFMut
from dataset.dna.synthetic.four_mutations.oops.read import SETS as SFMSETS
from dataset.dna.synthetic.four_mutations.zoops.read import getDataset as _getSynFMutZoops
from dataset.dna.synthetic.four_mutations.zoops.read import SETS as SFMZSETS
from dataset.dna.transfac.algorithm_markov.read import getDataset as _getTransfacAlgMchain
from dataset.dna.transfac.algorithm_markov.read import SETS as TAMSETS
from dataset.dna.transfac.algorithm_real.read import getDataset as _getTransfacAlgReal
from dataset.dna.transfac.algorithm_real.read import SETS as TARSETS
from dataset.dna.transfac.model_markov.read import getDataset as _getTransfacModelMchain
from dataset.dna.transfac.model_markov.read import SETS as TMMSETS
from dataset.dna.transfac.model_real.read import getDataset as _getTransfacModelReal
from dataset.dna.transfac.model_real.read import SETS as TMRSETS
from dataset.dna.transfac.remaining_markov.read import getDataset as _getTransfacRemainingMchain
from dataset.dna.transfac.remaining_markov.read import SETS as TRMSETS
from dataset.dna.transfac.remaining_real.read import getDataset as _getTransfacRemainingReal
from dataset.dna.transfac.remaining_real.read import SETS as TRRSETS




import DB_constants

def getTransfacRemainingReal(i = TRRSETS.keys()[0]):
	r = _getTransfacRemainingReal(i)
	r.db_source_id = DB_constants.TRANSFACTYPE
	r.db_type_id = DB_constants.KNOWN_MOTIFS
	return r

def getAllTransfacRemainingReal():
	r = []
	for line in TRRSETS: r.append(getTransfacRemainingReal(line))
	return r


def getTransfacRemainingMchain(i = TRMSETS.keys()[0]):
	r = _getTransfacRemainingMchain(i)
	r.db_source_id = DB_constants.TRANSFACTYPE
	r.db_type_id = DB_constants.KNOWN_MOTIFS
	return r

def getAllTransfacRemainingMchain():
	r = []
	for line in TRMSETS: r.append(getTransfacRemainingMchain(line))
	return r


def getTransfacModelReal(i = TMRSETS.keys()[0]):
	r = _getTransfacModelReal(i)
	r.db_source_id = DB_constants.TRANSFACTYPE
	r.db_type_id = DB_constants.KNOWN_MOTIFS
	return r

def getAllTransfacModelReal():
	r = []
	for line in TMRSETS: r.append(getTransfacModelReal(line))
	return r


def getTransfacModelMchain(i = TMMSETS.keys()[0]):
	r = _getTransfacModelMchain(i)
	r.db_source_id = DB_constants.TRANSFACTYPE
	r.db_type_id = DB_constants.KNOWN_MOTIFS
	return r

def getAllTransfacModelMchain():
	r = []
	for line in TMMSETS: r.append(getTransfacModelMchain(line))
	return r

def getTransfacAlgReal(i = TARSETS.keys()[0]):
	r = _getTransfacAlgReal(i)
	r.db_source_id = DB_constants.TRANSFACTYPE
	r.db_type_id = DB_constants.KNOWN_MOTIFS
	return r

def getAllTransfacAlgReal():
	r = []
	for line in TARSETS: r.append(getTransfacAlgReal(line))
	return r


def getTransfacAlgMchain(i = TAMSETS.keys()[0]):
	r = _getTransfacAlgMchain(i)
	r.db_source_id = DB_constants.TRANSFACTYPE
	r.db_type_id = DB_constants.KNOWN_MOTIFS
	return r

def getAllTransfacAlgMchain():
	r = []
	for line in TAMSETS: r.append(getTransfacAlgMchain(line))
	return r

def getSynFMutZoops(i = SFMZSETS.keys()[0]):
	r = _getSynFMutZoops(i)
	r.db_source_id = DB_constants.SYNTYPE
	r.db_type_id = DB_constants.KNOWN_MOTIFS
	return r

def getAllSynFMutZoops():
	r = []
	for line in SFMZSETS: r.append(getSynFMutZoops(line))
	return r

def getSynFMut(i = SFMSETS.keys()[0]):
	r = _getSynFMut(i)
	r.db_source_id = DB_constants.SYNTYPE
	r.db_type_id = DB_constants.KNOWN_MOTIFS
	return r

def getAllSynFMut():
	r = []
	for line in SFMSETS: r.append(getSynFMut(line))
	return r


def getSynXMut(i = SXMSETS.keys()[0]):
	r = _getSynXMut(i)
	r.db_source_id = DB_constants.SYNTYPE
	r.db_type_id = DB_constants.KNOWN_MOTIFS
	return r

def getAllSynXMut():
	r = []
	for line in SXMSETS: r.append(getSynXMut(line))
	return r





def getRealTompa(i=REALTOMPASETS.keys()[0]):
	r = _getRealTompa(i)
	r.db_source_id = DB_constants.TOMPATYPE
	r.db_type_id = DB_constants.MOTIF_WINDOWS
	r.motiflength = 10
	return r


def getAllRealTompa():
	r = []
	for line in REALTOMPASETS:
		r.append(getRealTompa(line))
	return r

def getMchainTompa(i=MCHAINTOMPASETS.keys()[0]):
	r = _getMchainTompa(i)
	r.db_source_id = DB_constants.TOMPATYPE
	r.db_type_id = DB_constants.MOTIF_WINDOWS
	return r

def getAllMchainTompa():
	r = []
	for line in MCHAINTOMPASETS:
		r.append(getMchainTompa(line))
	return r

def getGenericTompa(i=GENERICTOMPASETS.keys()[0]):
	r = _getGenericTompa(i)
	r.db_source_id = DB_constants.TOMPATYPE
	r.db_type_id = DB_constants.MOTIF_WINDOWS
	return r

def getAllGenericTompa():
	r = []
	for line in GENERICTOMPASETS:
		r.append(getGenericTompa(line))
	return r


if __name__ == "__main__":
	getAllGenericTompa()
