from ConfigParser import ConfigParser


class Dataset_info:
	def __init__(self, dataset=None):
		self.dataset = dataset

	def totalLetterCount(self, dataset=None):
		if dataset != None: self.dataset = dataset
		r = {}
		for sequence in self.dataset.getSequences():
			for letter in sequence:
				if r.has_key(letter):r[letter]+=1
				else: r[letter] = 1
		return r
	
	
	
	def backgroundCount(self):
		motiflength = self.motiflength()
		sequences = self.dataset.getSequences()
		resetlist = None
		if self.dataset.db_source_id == 3:
			c = ConfigParser()
			f = file("blocksindexes.conf")
			c.readfp(f)
			f.close()
			mlen, alignment = None, None
			mw = self.dataset.getMotifWindows()
			resetlist = self.dataset.getMotifWindows()
			mw.sort()
			
			
			if c.has_option("length", self.dataset._filename):
				mlen = c.getint("length", self.dataset._filename)
				alignment = c.get("indexes", self.dataset._filename)[1:][:-1].split(",")
				for i in range(len(alignment)):alignment[i] = int(alignment[i])
			else: 
				print "No blocks entry found for dataset. Run a standard Blocks-test first"
				return
			
			if motiflength == -1:
				motiflength = mlen
			
			
	
			for i in range(len(mw)):
				seqid, pos, length = mw[i]
				mw[i] = (seqid, pos+alignment[i], mlen)
	
			self.dataset.setMotifHitlist(mw)
		
		windows = self.dataset.getMotifWindows()
		totalCount = 0
		for line in self.dataset.getSequences():
			totalCount += len(line)
		for i, j, k in windows:
			totalCount -= k
		
			
			
			
		
		if self.dataset.db_source_id == 3:self.dataset.setMotifHitlist(resetlist)
		return totalCount
		
		
	def conservity(self):
		motiflength = self.motiflength()
		sequences = self.dataset.getSequences()
		resetlist = None
		if self.dataset.db_source_id == 3:
			c = ConfigParser()
			f = file("blocksindexes.conf")
			c.readfp(f)
			f.close()
			mlen, alignment = None, None
			mw = self.dataset.getMotifWindows()
			resetlist = self.dataset.getMotifWindows()
			mw.sort()
			
			
			if c.has_option("length", self.dataset._filename):
				mlen = c.getint("length", self.dataset._filename)
				alignment = c.get("indexes", self.dataset._filename)[1:][:-1].split(",")
				for i in range(len(alignment)):alignment[i] = int(alignment[i])
			else: 
				print "No blocks entry found for dataset. Run a standard Blocks-test first"
				return
			
			if motiflength == -1:
				motiflength = mlen
			
			
	
			for i in range(len(mw)):
				seqid, pos, length = mw[i]
				mw[i] = (seqid, pos+alignment[i], mlen)
	
			self.dataset.setMotifHitlist(mw)
		
		motifpos = self.dataset.getMotifIndexes()
		cons = []
		for i in range(motiflength): cons.append(set())
		
		for i, j in motifpos:
			mot = sequences[i][j:j+motiflength]
			
				
			for k, l in enumerate(mot):
				cons[k].add(l)
		r = []
		for i in range(motiflength):
			line = list(cons[i])
			line.sort()
			r.append(str(len(line)))
		r = ":".join(r)
			
			
			
		if self.dataset.db_source_id == 3:self.dataset.setMotifHitlist(resetlist)
		return r
	
	def motifDistance(self):
		import SearchUtils
		motiflength = self.motiflength()
		sequences = self.dataset.getSequences()
		resetlist = None
		if self.dataset.db_source_id == 3:
			c = ConfigParser()
			f = file("blocksindexes.conf")
			c.readfp(f)
			f.close()
			mlen, alignment = None, None
			mw = self.dataset.getMotifWindows()
			resetlist = self.dataset.getMotifWindows()
			mw.sort()
			
			
			if c.has_option("length", self.dataset._filename):
				mlen = c.getint("length", self.dataset._filename)
				alignment = c.get("indexes", self.dataset._filename)[1:][:-1].split(",")
				for i in range(len(alignment)):alignment[i] = int(alignment[i])
			else: 
				print "No blocks entry found for dataset. Run a standard Blocks-test first"
				return
			
			if motiflength == -1:
				motiflength = mlen
			
			
	
			for i in range(len(mw)):
				seqid, pos, length = mw[i]
				mw[i] = (seqid, pos+alignment[i], mlen)
	
			self.dataset.setMotifHitlist(mw)
		
		motifpos = self.dataset.getMotifIndexes()
		motifList = []
		for i, j in motifpos:
			motifList.append(sequences[i][j:j+motiflength])
		
		dist = 0
		tempc = 0
		for i in range(len(motifList)-1):
			for j in range(i+1, len(motifList)):
				tempc += 1
				dist += SearchUtils.hdistance_int(motifList[i], motifList[j])
		
		
		
		if self.dataset.db_source_id == 3:self.dataset.setMotifHitlist(resetlist)
		return float(dist)/tempc
		
		
	def motifs(self, dataset = None):
		motiflength = self.motiflength()
		sequences = self.dataset.getSequences()
		resetlist = None
		if self.dataset.db_source_id == 3:
			c = ConfigParser()
			f = file("blocksindexes.conf")
			c.readfp(f)
			f.close()
			mlen, alignment = None, None
			mw = self.dataset.getMotifWindows()
			resetlist = self.dataset.getMotifWindows()
			mw.sort()
			
			
			if c.has_option("length", self.dataset._filename):
				mlen = c.getint("length", self.dataset._filename)
				alignment = c.get("indexes", self.dataset._filename)[1:][:-1].split(",")
				for i in range(len(alignment)):alignment[i] = int(alignment[i])
			else: 
				print "No blocks entry found for dataset. Run a standard Blocks-test first"
				return
			
			if motiflength == -1:
				motiflength = mlen
			
			
	
			for i in range(len(mw)):
				seqid, pos, length = mw[i]
				mw[i] = (seqid, pos+alignment[i], mlen)
	
			self.dataset.setMotifHitlist(mw)
		r = []
		for i, j in self.dataset.getMotifIndexes():
			r.append( sequences[i][j:j+motiflength] )
			
		
		if self.dataset.db_source_id == 3:self.dataset.setMotifHitlist(resetlist)
			
		return r
	
	def motiflength(self):
		if self.dataset.db_source_id == 3:
			c = ConfigParser()
			f = file("blocksindexes.conf")
			c.readfp(f)
			f.close()
			if c.has_option("length", self.dataset._filename):
				mlen = c.getint("length", self.dataset._filename)
				return mlen
			else: 
				print "error: not found"
				return -1
		else:
			return self.dataset.getMotifWindows()[0][2]
		
	def factorial(self, n):
		if n<=1:
			return 1
		else:
			return n * self.factorial(n-1)
	
	def combinations(self, n, r):
		return self.factorial(n)/(self.factorial(r)*(self.factorial(n-r)))
				
if __name__=="__main__":
	import Dataset
	import DB_constants
	
	CREBTYPE			= 1
	MOTIFSEARCHTYPE 	= 2
	TOMPATYPE			= 3
	TRANSFACTYPE		= 4
	KNOWN_MOTIFS		= 1
	MOTIF_WINDOWS		= 2
	
	datasets = Dataset.getEverything()
	
	html = ["<html><body><table>"]
	for d in datasets:
		if d.db_source_id == MOTIFSEARCHTYPE: continue
		a = Dataset_info(d)
		temp = "<tr><td>"
		tmd = str(a.motifDistance())
		
		tmd = tmd[:tmd.find(".")+2]
		tmd = tmd.replace(".", ",")
		
		temp += "</td><td>".join([d._filename, str(a.motiflength()), str(len(a.motifs())),\
			str(len(d.getSequences())), str(a.backgroundCount()), a.conservity(), tmd])
		temp += "</td></tr>"
		html += [temp]
		
		
	html += ["</table></body></table>"]
	

	f = file("c:\\ms_summary.html", "w")
	for line in html:
		f.write(line + "\n")
	f.close()
				
				