from Result import OBJECTFOLDER, Result

from Dataset import getRealTompa, getGenericTompa, getMchainTompa, getAllFTransfac
from DB_constants import TOMPATYPE
import ScoreFunc as sf
import os, re
from ExtractMeme import tf_getScoreNucleotideLevel, tm_getScoreNucleotideLevel
from ConfigParser import ConfigParser
from ScoreFunc import wcc
cc = wcc(0)
Set = set
def writeTableBars(fname, input, gl):
	fp = file(fname, "w")
	html = ["<html>", "<body>", "<table>"]
	tmp = "<tr><th></th>"
	for i in input:
		
		if "label" in i:
				tmp += "<th>%s</th>" % i["label"]
			
		else: tmp += "<th>Undefined</th>"
	html.append(tmp+"</tr>")

	for i in range(len(input[0]["values"])):
		tmp = "<tr><td>%s</td>" % gl[i]
		for j in range(len(input)):
			tmp += "<td>%s</td>" % input[j]["values"][i]
		tmp += "</tr>"
			
		html.append(tmp)
	html += ["</table>", "</body>", "</html>"]
	
	
	
	fp.write( "\n".join(html))
	fp.close()


def writeTableLines(fname, input):
	fp = file(fname, "w")
	html = ["<html>", "<body>", "<table>"]
	tmp = "<tr>"
	for i in input:
		if "lineproperties" in i:
			if "label" in i['lineproperties']:
				tmp += "<th>%s</th>" % i["lineproperties"]["label"]
			else: tmp += "<th>Undefined</th>"
		else: tmp += "<th>Undefined</th>"
	html.append(tmp+"</tr>")
	
	for i in range(len(input[0]["y"])):
		tmp = "<tr>"
		for j in range(len(input)):
			tmp += "<td>%s</td>" % input[j]["y"][i]
		tmp += "</tr>"
			
		html.append(tmp)
	html += ["</table>", "</body>", "</html>"]
	
	
	
	fp.write( "\n".join(html))
	fp.close()




def getResultAttributes(subfolder, pattern, *attributes):
	if subfolder[-1] not in ("\\", "/", os.sep): subfolder += os.sep
	
	pattern = re.compile(pattern)
	
	rootfolder = OBJECTFOLDER+subfolder
	_files = os.listdir(rootfolder)
	_files.sort()
	files = []
	for f in _files:
		
		if pattern.match(f): files.append(f)
	ret = {}
	res = Result()
	for f in files:
		res.read(subfolder + f)
		#print dir(res.m)
		variables = vars(res.m)
		for att in attributes:
			if f not in ret: ret[f] = [variables[att]]
			else: ret[f].append(variables[att])
	return files, ret
		
	
def alteredHits(subfolder, pattern):
	key, res = getResultAttributes(subfolder, pattern, "hitlist", "dataset", "TP", "FN", "FP", "TN")
	cc = sf.wcc(0)
	ret = {}
	for ke in key:
		hitlist, dataset, tTP, tFN, tFP, tTN = res[ke]
		
		
		
		totpos = 0
		for line in dataset.getSequences():
			totpos += len(line)
		
		hitset, instanceset = Set(), Set()
		rallmw = dataset.getMotifWindows()
		try:
			dataset.db_source_id
		except:
			dataset.db_source_id = TOMPATYPE
		
		if dataset.db_source_id == TOMPATYPE:
			decider = dataset._filename[dataset._filename.find(".fasta")-1]
			
			if decider == "r":
				tdataset = getRealTompa(dataset._filename)
				rallmw = tdataset.getMotifWindows()
			elif decider == "g":
				
				tdataset = getGenericTompa(dataset._filename)
				rallmw = tdataset.getMotifWindows()
			elif decider == "m":
				tdataset = getMchainTompa(dataset._filename)
				rallmw = tdataset.getMotifWindows()
			
				
		
		for i, j, mlen in rallmw:
			for k in range(j, j+mlen):
				
				instanceset.add((i, k))
		
		mlen = dataset.getMotifWindows()[0][-1]
		"""
		#since getWindows has been altered anyway this has been commented out.
		if dataset.db_source_id == TOMPATYPE:
			
			c = ConfigParser()
			f = file("blocksindexes.conf")
			c.readfp(f)
			f.close()
			mlen = c.getint("length", dataset._filename)
		"""
		
		
		for i, j in hitlist:
			for k in range(j, j+mlen):
				hitset.add((i, k))
		
		TP, FP, FN = len(hitset & instanceset), len(hitset - instanceset), len(instanceset-hitset)
		TN = totpos - TP-FP-FN
		
		
		
	
		ret[ke] = [(TP, FN, FP, TN), (tTP, tFN, tFP, tTN)]
	return key, ret
		
			
def averageChangeInScoringFunction(scorefunc, hits, keys=None):
	
	if keys == None:
		keys = hits.keys()
		keys.sort()
	
	new, old = [], []
	for ke in keys:
		new.append(scorefunc(*hits[ke][0])), old.append(scorefunc(*hits[ke][1]))
	return keys, float(sum(new))/len(new), float(sum(old))/len(old)


def final_figure1(): #previously figure1a
	k1, hdscores = 0, 0
	k2, rescores = 0, 0
	k3, pwscores = 0, 0
	##exact positions
	if 0:
		
		k1, hdscores = getResultAttributes("added/real/hdi/", ".+fas", "score")
		k2, rescores = getResultAttributes("added/real/reg/", ".+fas", "score")
		k3, pwscores = getResultAttributes("added/real/pwm/", ".+fas", "score")
		k1.sort()
		k2.sort()
		k3.sort()
	
	##nucleotide level
	else:
		k1, hdscores =  alteredHits("added/real/hdi/", ".+fas")
		for k in hdscores:	hdscores[k] = [cc.fitness(*hdscores[k][0])]
		k2, rescores =  alteredHits("added/real/reg/", ".+fas")
		for k in rescores:	rescores[k] = [cc.fitness(*rescores[k][0])]
		k3, pwscores =  alteredHits("added/real/pwm/", ".+fas")
		for k in pwscores:	pwscores[k] = [cc.fitness(*pwscores[k][0])]
		k1.sort()
		k2.sort()
		k3.sort()
	
	
	
	
	hd, re, pw, best = [], [], [], []
	for k, l, m in zip(k1, k2, k3):
		if not k[:10] ==l[:10]==m[:10]: print "hhyyyyllll"
		
		
		hd.append(hdscores[k][0])
		re.append(rescores[l][0])
		pw.append(pwscores[m][0])
		
		best.append(max((hdscores[k][0], rescores[l][0], pwscores[m][0])))
	
	hd.sort()
	re.sort()
	pw.sort()
	best.sort()
	
	
	import GraphGen as gg
	
	input = []
	linetype = gg.SIMPLE
	input.append({'x':range(len(hd)), 'y':hd, 'type':linetype,\
						'lineproperties':{'label':'MM', 'marker':'.', 'linewidth':1, 'color':'b',\
						'markerfacecolor':'b'}})
	input.append({'x':range(len(re)), 'y':re, 'type':linetype,\
						'lineproperties':{'label':'IUPAC', 'marker':'.', 'linewidth':1, 'color':'r',\
						'markerfacecolor':'r'}})
	input.append({'x':range(len(pw)), 'y':pw, 'type':linetype,\
						'lineproperties':{'label':'PWM', 'marker':'.', 'linewidth':1, 'color':'g',\
						'markerfacecolor':'g'}})
	"""
	input.append({'x':range(len(best)), 'y':best, 'type':linetype,\
						'lineproperties':{'label':'Best', 'marker':'.', 'linewidth':1, 'color':'y',\
						'markerfacecolor':'y'}})
	"""				
	writeTableLines("c:\\figures\\figur_1a.html", input)
	
	gg.simplePlot(input, axis=[0, len(re), 0, 1.1], title=" ", xlabel=" ", ylabel="nCC", fname="C:\\figures\\final\\fig1", showWindow = True)
	

def figure1b():
	##exact positions
	
	k1, hdscores = getResultAttributes("added/real/hdi/", ".+fas", "score")
	k2, rescores = getResultAttributes("added/real/reg/", ".+fas", "score")
	k3, pwscores = getResultAttributes("added/real/pwm/", ".+fas", "score")
	k1.sort()
	k2.sort()
	k3.sort()
	
	##n-level
	k1, hdscores =  alteredHits("added/real/hdi/", ".+fas")
	
	k2, rescores =  alteredHits("added/real/reg/", ".+fas")
	
	k3, pwscores =  alteredHits("added/real/pwm/", ".+fas")
	k1.sort()
	k2.sort()
	k3.sort()
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k1:
		tTP, tFN, tFP, tTN = hdscores[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	hdscores = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k2:
		tTP, tFN, tFP, tTN = rescores[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	rescores = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k3:
		tTP, tFN, tFP, tTN = pwscores[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	pwscores = cc.fitness(TP, FN, FP, TN)
	
	
	from operator import itemgetter as ig
	getfirst = ig(0)
	
	
	
	
	
	import GraphGen as gg
	input = []
	
	input.append({'values':[hdscores], 'color':'b', 'label':'Hamming distance'})
	
	input.append({'values':[rescores], 'color':'r', 'label':'IUPAC'})
	
	input.append({'values':[pwscores], 'color':'g', 'label':'PWM'})
	
	groupLabels = ["Total scores"]
	
	
	writeTableBars("c:\\figures\\figure_1b.html", input, groupLabels)
	
	
	gg.simpleBars(input, yaxis=[0, 1.1], showWindow=True, xticks = groupLabels, title="figur_1b", xlabel="", ylabel="Average CC", fname="c:\\figures\\*")
	
	
	
	
def final_figure2(): #figur1c
	##n-level
	k1, hdrs =  alteredHits("nye_resultat/tompa_d/real/", ".+hdi.+res")
	
	k2, rers =  alteredHits("nye_resultat/tompa_d/real/", ".+reg.+res")
	
	k3, pwrs =  alteredHits("nye_resultat/tompa_d/real/", ".+p[bw]m.+res")
	
	k4, hdms =  alteredHits("nye_resultat/tompa_d/mchain/", ".+hdi.+res")
	
	k5, rems =  alteredHits("nye_resultat/tompa_d/mchain/", ".+reg.+res")
	
	k6, pwms =  alteredHits("nye_resultat/tompa_d/mchain/", ".+p[bw]m.+res")
	
	k7, hdgs =  alteredHits("nye_resultat/tompa_d/generic/", ".+hdi.+res")
	
	k8, regs =  alteredHits("nye_resultat/tompa_d/generic/", ".+reg.+res")
	
	k9, pwgs =  alteredHits("nye_resultat/tompa_d/generic/", ".+p[bw]m.+res")
	
	
	
	k1.sort()
	k2.sort()
	k3.sort()
	k4.sort()
	k5.sort()
	k6.sort()
	k7.sort()
	k8.sort()
	k9.sort()
	
	
	index = 0
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k1:
		tTP, tFN, tFP, tTN = hdrs[k][index]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	hdrs = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k2:
		tTP, tFN, tFP, tTN = rers[k][index]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	rers = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k3:
		tTP, tFN, tFP, tTN = pwrs[k][index]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	pwrs = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k4:
		tTP, tFN, tFP, tTN = hdms[k][index]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	hdms = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k5:
		tTP, tFN, tFP, tTN = rems[k][index]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	rems = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k6:
		tTP, tFN, tFP, tTN = pwms[k][index]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	pwms = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k7:
		tTP, tFN, tFP, tTN = hdgs[k][index]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	hdgs = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k8:
		tTP, tFN, tFP, tTN = regs[k][index]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	regs = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k9:
		tTP, tFN, tFP, tTN = pwgs[k][index]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	pwgs = cc.fitness(TP, FN, FP, TN)
	
	
	import GraphGen as gg
	input = []
	input.append({'values':[hdrs, hdms, hdgs], 'color':'b', 'label':'MM'})
	input.append({'values':[rers, rems, regs], 'color':'r', 'label':'IUPAC'})
	input.append({'values':[pwrs, pwms, pwgs], 'color':'g', 'label':'PWM'})
	
	groupLabels = ["Real", "Markov", "Generic"]
	
	writeTableBars("c:\\figures\\figure_1c.html", input, groupLabels)
	gg.simpleBars(input, yaxis=[0, 1.1], showWindow=True, xticks = groupLabels, title=" ", xlabel="", ylabel="nCC", fname="c:\\figures\\final\\fig2")
	
def figure1ctest():
	##n-level
	k1, hdrs =  alteredHits("nye_resultat/tompa_d/real/", ".+hdi.+res")
	
	k2, rers =  alteredHits("nye_resultat/tompa_d/real/", ".+reg.+res")
	
	k3, pwrs =  alteredHits("nye_resultat/tompa_d/real/", ".+p[bw]m.+res")
	
	k4, hdms =  alteredHits("nye_resultat/tompa_d/mchain/", ".+hdi.+res")
	
	k5, rems =  alteredHits("nye_resultat/tompa_d/mchain/", ".+reg.+res")
	
	k6, pwms =  alteredHits("nye_resultat/tompa_d/mchain/", ".+p[bw]m.+res")
	
	k7, hdgs =  alteredHits("nye_resultat/tompa_d/generic/", ".+hdi.+res")
	
	k8, regs =  alteredHits("nye_resultat/tompa_d/generic/", ".+reg.+res")
	
	k9, pwgs =  alteredHits("nye_resultat/tompa_d/generic/", ".+p[bw]m.+res")
	
	
	
	k1.sort()
	k2.sort()
	k3.sort()
	k4.sort()
	k5.sort()
	k6.sort()
	k7.sort()
	k8.sort()
	k9.sort()
	
	
	index = 1
	
	TP, FP, FN, TN = 0, 0, 0, 0
	t = 0
	for k in k1:
		t += cc.fitness(*hdrs[k][index])
		
	hdrs = t/len(hdrs)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	t = 0
	for k in k2:
		t += cc.fitness(*rers[k][index])
	rers = t/len(rers)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	t = 0
	for k in k3:
		t += cc.fitness(*pwrs[k][index])
	pwrs = t/len(pwrs)
	
	
	TP, FP, FN, TN = 0, 0, 0, 0
	t = 0
	for k in k4:
		t += cc.fitness(*hdms[k][index])
	hdms = t/len(hdms)
	
	
	TP, FP, FN, TN = 0, 0, 0, 0
	t = 0
	for k in k5:
		t += cc.fitness(*rems[k][index])
	rems = t/len(rems)
	
	
	TP, FP, FN, TN = 0, 0, 0, 0
	t = 0
	for k in k6:
		t += cc.fitness(*pwms[k][index])
	pwms = t/len(pwms)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	t = 0
	for k in k7:
		t += cc.fitness(*hdgs[k][index])
	hdgs = t/len(hdgs)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	t = 0
	for k in k8:
		t += cc.fitness(*regs[k][index])
	regs = t/len(regs)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	t = 0
	for k in k9:
		t += cc.fitness(*pwgs[k][index])
	pwgs = t/len(pwgs)
	
	import GraphGen as gg
	input = []
	input.append({'values':[hdrs, hdms, hdgs], 'color':'b', 'label':'Hamming distance'})
	input.append({'values':[rers, rems, regs], 'color':'r', 'label':'IUPAC'})
	input.append({'values':[pwrs, pwms, pwgs], 'color':'g', 'label':'PWM'})
	
	groupLabels = ["Real", "Markov", "Generic"]
	
	
	gg.simpleBars(input, yaxis=[0, 1], showWindow=True, xticks = groupLabels, title="hylix_det", xlabel="", ylabel="Average CC", fname="c:\\figures\\*")	
	
def figure2():
	import pickle as p
	r = p.load(file("results.dict"))
	mdaverage = {}
	mdbest = {}
	dbest = {}
	
	tmp = []
	for k in r:
		tmp.append(k)
		for dname, TP, FN, FP, TN in r[k]:
			if dname in mdaverage: mdaverage[dname].append(cc.fitness(TP, FN, FP, TN))
			else: mdaverage[dname] = [cc.fitness(TP, FN, FP, TN)]
	print mdaverage
	print "#"*50
	for k in mdaverage:
		
		mdbest[k] = max(mdaverage[k])
		mdaverage[k] = sum(mdaverage[k])/len(mdaverage[k])
		#print k, mdaverage[k], mdbest[k]
	
	pwgk, pwgs = alteredHits("added/generic/pwm", ".+res")
	pwmk, pwms = alteredHits("added/mchain/pwm", ".+res")
	pwrk, pwrs = alteredHits("added/real/pwm", ".+res")
	
	regk, regs = alteredHits("added/generic/reg", ".+res")
	remk, rems = alteredHits("added/mchain/reg", ".+res")
	rerk, rers = alteredHits("added/real/reg", ".+res")
	
	hdgk, hdgs = alteredHits("added/generic/hdi", ".+res")
	hdmk, hdms = alteredHits("added/mchain/hdi", ".+res")
	hdrk, hdrs = alteredHits("added/real/hdi", ".+res")
	
	
	
	"""
	pwgk, pwgs = getResultAttributes("added/generic/pwm", ".+res", "TP", "FN", "FP", "TN")
	pwmk, pwms = getResultAttributes("added/mchain/pwm", ".+res", "TP", "FN", "FP", "TN")
	pwrk, pwrs = getResultAttributes("added/real/pwm", ".+res", "TP", "FN", "FP", "TN")
	
	regk, regs = getResultAttributes("added/generic/reg", ".+res", "TP", "FN", "FP", "TN")
	remk, rems = getResultAttributes("added/mchain/reg", ".+res", "TP", "FN", "FP", "TN")
	rerk, rers = getResultAttributes("added/real/reg", ".+res", "TP", "FN", "FP", "TN")
	
	hdgk, hdgs = getResultAttributes("added/generic/hdi", ".+res", "TP", "FN", "FP", "TN")
	hdmk, hdms = getResultAttributes("added/mchain/hdi", ".+res", "TP", "FN", "FP", "TN")
	hdrk, hdrs = getResultAttributes("added/real/hdi", ".+res", "TP", "FN", "FP", "TN")
	"""
	
	
	
	
	getResultAttributes("added/real/hdi", ".+res", "TP", "FN", "FP", "TN")
	disckeys = pwgk + pwmk + pwrk + regk + remk + rerk + hdgk + hdmk + hdrk
	
	keys = mdaverage.keys()
	
	
	connection = {}
	discarded = []
	for k in keys:
		tmp = []
		for dk in disckeys:
			if k in dk: tmp.append(dk)
		if tmp: connection[k] = tmp
		else:discarded.append(k)
	
	for k in connection:
		pwmkey, regkey, hdikey = connection[k]
		if k[-1] == "g":

			tp = cc.fitness(*pwgs[pwmkey][0])
			tr = cc.fitness(*regs[regkey][0])
			th = cc.fitness(*hdgs[hdikey][0])
			dbest[k] = max((tp, tr, th))
		elif k[-1] == "m":

			tp = cc.fitness(*pwms[pwmkey][0])
			tr = cc.fitness(*rems[regkey][0])
			th = cc.fitness(*hdms[hdikey][0])
			dbest[k] = max((tp, tr, th))
		elif k[-1] == "r":

			tp = cc.fitness(*pwrs[pwmkey][0])
			tr = cc.fitness(*rers[regkey][0])
			th = cc.fitness(*hdrs[hdikey][0])
			dbest[k] = max((tp, tr, th))
				
	temp = [(dbest[k], k) for k in dbest]
	temp.sort()
	key = [k for d, k in temp]
	
	
	
	discriminationScores = []
	tompaBestScores = []
	tompaAverageScores = []
	
	for k in key:
		discriminationScores.append(dbest[k])
		tompaBestScores.append(mdbest[k])
		tompaAverageScores.append(mdaverage[k])
		
		if mdbest[k] > dbest[k]:
			print k
		
	
	import GraphGen as gg
	
	input = []
	linetype = gg.SIMPLE
	
	from pylab import corrcoef
	print corrcoef(discriminationScores, tompaBestScores)
	print corrcoef(discriminationScores, tompaAverageScores)
	
	
	
	input.append({'x':range(len(discriminationScores)), 'y':discriminationScores, 'type':linetype,\
						'lineproperties':{'label':'Discrimination, best scores', 'marker':'.', 'linewidth':1, 'color':'b',\
						'markerfacecolor':'b'}})
	input.append({'x':range(len(tompaBestScores)), 'y':tompaBestScores, 'type':linetype,\
						'lineproperties':{'label':'Tompa, best scores', 'marker':'.', 'linewidth':1, 'color':'r',\
						'markerfacecolor':'r'}})
	input.append({'x':range(len(tompaAverageScores)), 'y':tompaAverageScores, 'type':linetype,\
						'lineproperties':{'label':'Tompa, average scores', 'marker':'.', 'linewidth':1, 'color':'g',\
						'markerfacecolor':'g'}})
						
	writeTableLines("c:\\figures\\figure_2.html", input)
	gg.simplePlot(input, axis=[0, len(tompaBestScores), 0, 1.1], title="figur_2", xlabel=" ", ylabel="CC", fname="C:\\figures\\*", showWindow = True)
	



def figure3():
	##n-level
	k1, hdscores =  alteredHits("nye_resultat/tompa_cv/hdi/", r".+r\..+res")
	k2, rescores =  alteredHits("nye_resultat/tompa_cv/reg/", r".+r\..+res")
	k3, pwscores =  alteredHits("nye_resultat/tompa_cv/pwm/", r".+r\..+res")

	
	k1.sort()
	k2.sort()
	k3.sort()
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k1:
		tTP, tFN, tFP, tTN = hdscores[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	hdscores = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k2:
		tTP, tFN, tFP, tTN = rescores[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	rescores = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in k3:
		tTP, tFN, tFP, tTN = pwscores[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	pwscores = cc.fitness(TP, FN, FP, TN)
	
	
	from operator import itemgetter as ig
	getfirst = ig(0)
	
	
	
	
	
	import GraphGen as gg
	input = []
	
	input.append({'values':[hdscores], 'color':'b', 'label':'Hamming distance'})
	
	input.append({'values':[rescores], 'color':'r', 'label':'IUPAC'})
	
	input.append({'values':[pwscores], 'color':'g', 'label':'PWM'})
	
	groupLabels = ["Total scores"]
	
	writeTableBars("c:\\figures\\figure_3.html", input, groupLabels)
	gg.simpleBars(input, yaxis=[0, 1.1], showWindow=True, xticks = groupLabels, title="figur_3a", xlabel="", ylabel="Average CC", fname="c:\\figures\\*")

def final_figure3(): #figure4
	import pickle as p
	r = p.load(file("results.dict"))
	
	res = {}
	keys = Set()
	
	for k in r:
		TP, FN, FP, TN = 0,0,0,0
		for dname, tTP, tFN, tFP, tTN in r[k]:
			keys.add(dname)
			TP += tTP
			FP += tFP
			FN += tFN
			TN += tTN
		res[k] = cc.fitness(TP, FN, FP, TN)
	keys = list(keys)
	keys.sort()
	
			
			
	"""
	for k in mdaverage:
		mdbest[k] = max(mdaverage[k])
		mdaverage[k] = sum(mdaverage[k])/len(mdaverage[k])
	"""
	
	pwgk, pwgs = alteredHits("added/generic/pwm", ".+res")
	pwmk, pwms = alteredHits("added/mchain/pwm", ".+res")
	pwrk, pwrs = alteredHits("added/real/pwm", ".+res")
	
	regk, regs = alteredHits("added/generic/reg", ".+res")
	remk, rems = alteredHits("added/mchain/reg", ".+res")
	rerk, rers = alteredHits("added/real/reg", ".+res")
	
	hdgk, hdgs = alteredHits("added/generic/hdi", ".+res")
	hdmk, hdms = alteredHits("added/mchain/hdi", ".+res")
	hdrk, hdrs = alteredHits("added/real/hdi", ".+res")
	
	disckeys = pwgk + pwmk + pwrk + regk + remk + rerk + hdgk + hdmk + hdrk
	
	
	
	
	connection = {}
	discarded = []
	for k in keys:
		tmp = []
		for dk in disckeys:
			if k in dk: tmp.append(dk)
		if tmp: connection[k] = tmp
		else:discarded.append(k)
	
	
	pTP, pFN, pFP, pTN, rTP, rTN, rFP, rFN, hTP, hTN, hFP, hFN = [0] * 12
	for k in connection:
		pwmkey, regkey, hdikey = connection[k]
		
		
		
		
		if k[-1] == "g":

			a, b, c, d =  pwgs[pwmkey][0]
			pTP += a
			pFN += b
			pFP += c
			pTN += d
			a, b, c, d =  regs[regkey][0]
			rTP += a
			rFN += b
			rFP += c
			rTN += d
			a, b, c, d =  hdgs[hdikey][0]
			hTP += a
			hFN += b
			hFP += c
			hTN += d
			
		elif k[-1] == "m":

			a, b, c, d =  pwms[pwmkey][0]
			pTP += a
			pFN += b
			pFP += c
			pTN += d
			a, b, c, d =  rems[regkey][0]
			rTP += a
			rFN += b
			rFP += c
			rTN += d
			a, b, c, d =  hdms[hdikey][0]
			hTP += a
			hFN += b
			hFP += c
			hTN += d
			
			
		elif k[-1] == "r":

			a, b, c, d =  pwrs[pwmkey][0]
			pTP += a
			pFN += b
			pFP += c
			pTN += d			
			a, b, c, d =  rers[regkey][0]
			rTP += a
			rFN += b
			rFP += c
			rTN += d			
			a, b, c, d =  hdrs[hdikey][0]
			hTP += a
			hFN += b
			hFP += c
			hTN += d
	res2 = {}	
	
	res2["MM separation"] = cc.fitness(hTP, hFN, hFP, hTN)
	res2["IUPAC separation"] = cc.fitness(rTP, rFN, rFP, rTN)
	res2["PWM separation"] = cc.fitness(pTP, pFN, pFP, pTN)
	
	## Prediction
	
	pwgk, pwgs = alteredHits(r"nye_resultat\tompa_cv\pwm", ".+g.fasta.+res")
	pwmk, pwms = alteredHits(r"nye_resultat\tompa_cv\pwm", ".+m.fasta.+res")
	pwrk, pwrs = alteredHits(r"nye_resultat\tompa_cv\pwm", ".+r.fasta.+res")
	
	regk, regs = alteredHits(r"nye_resultat\tompa_cv\reg", ".+g.fasta.+res")
	remk, rems = alteredHits(r"nye_resultat\tompa_cv\reg", ".+m.fasta.+res")
	rerk, rers = alteredHits(r"nye_resultat\tompa_cv\reg", ".+r.fasta.+res")
	
	hdgk, hdgs = alteredHits(r"nye_resultat\tompa_cv\hdi", ".+g.fasta.+res")
	hdmk, hdms = alteredHits(r"nye_resultat\tompa_cv\hdi", ".+m.fasta.+res")
	hdrk, hdrs = alteredHits(r"nye_resultat\tompa_cv\hdi", ".+r.fasta.+res")
	
	
	
	disckeys = pwgk + pwmk + pwrk + regk + remk + rerk + hdgk + hdmk + hdrk
	
	
	
	
	connection = {}
	discarded = []
	for k in keys:
		tmp = []
		for dk in disckeys:
			if k in dk: tmp.append(dk)
		if tmp: connection[k] = tmp
		else:discarded.append(k)
	
	
	pTP, pFN, pFP, pTN, rTP, rTN, rFP, rFN, hTP, hTN, hFP, hFN = [0] * 12
	for k in connection:
		pwmkey, regkey, hdikey = connection[k]
		
		
		
		
		if k[-1] == "g":

			a, b, c, d =  pwgs[pwmkey][0]
			pTP += a
			pFN += b
			pFP += c
			pTN += d
			a, b, c, d =  regs[regkey][0]
			rTP += a
			rFN += b
			rFP += c
			rTN += d
			a, b, c, d =  hdgs[hdikey][0]
			hTP += a
			hFN += b
			hFP += c
			hTN += d
			
		elif k[-1] == "m":

			a, b, c, d =  pwms[pwmkey][0]
			pTP += a
			pFN += b
			pFP += c
			pTN += d
			a, b, c, d =  rems[regkey][0]
			rTP += a
			rFN += b
			rFP += c
			rTN += d
			a, b, c, d =  hdms[hdikey][0]
			hTP += a
			hFN += b
			hFP += c
			hTN += d
			
			
		elif k[-1] == "r":

			a, b, c, d =  pwrs[pwmkey][0]
			pTP += a
			pFN += b
			pFP += c
			pTN += d			
			a, b, c, d =  rers[regkey][0]
			rTP += a
			rFN += b
			rFP += c
			rTN += d			
			a, b, c, d =  hdrs[hdikey][0]
			hTP += a
			hFN += b
			hFP += c
			hTN += d
			
	
	res2["MM prediction"] = cc.fitness(hTP, hFN, hFP, hTN)
	res2["IUPAC prediction"] = cc.fitness(rTP, rFN, rFP, rTN)
	res2["PWM prediction"] = cc.fitness(pTP, pFN, pFP, pTN)
	
	import GraphGen as g
	from random import choice
	
	input = []
	
	for k, v in res.iteritems():
		input.append({'values':[v], 'color':'#'+"".join([choice("1234567890abcdef") for i in range(6)]), 'label':k})
		
		
	keys = ["MM prediction", "IUPAC prediction", "PWM prediction", "MM separation", "IUPAC separation", "PWM separation"]
	for k in keys:
		input.append({'values':[res2[k]], 'color':'#'+"".join([choice("1234567890abcdef") for i in range(6)]), 'label':k})
	
	for line in input: print line
	groupLabels = [" "]
	
	writeTableBars("c:\\figures\\figure_4.html", input, groupLabels)
	g.simpleBars(input, axis=[0, 40, 0, 1.1], showWindow=True, xticks = groupLabels, fname="c:\\Figures\\final\\fig3", title=" ", xlabel=" ", ylabel="nCC")
	
def final_figure5(): #figure5
	hfmok, hfmos = alteredHits(r"nye_resultat\synthetic_d", "fmo.+hdi.+")
	rfmok, rfmos = alteredHits(r"nye_resultat\synthetic_d", "fmo.+reg.+")
	pfmok, pfmos = alteredHits(r"nye_resultat\synthetic_d", "fmo.+pwm.+")
	hfmzk, hfmzs = alteredHits(r"nye_resultat\synthetic_d", "fmz.+hdi.+")
	rfmzk, rfmzs = alteredHits(r"nye_resultat\synthetic_d", "fmz.+reg.+")
	pfmzk, pfmzs = alteredHits(r"nye_resultat\synthetic_d", "fmz.+pwm.+")
	hsynk, hsyns = alteredHits(r"nye_resultat\synthetic_d", "syn.+hdi.+")
	rsynk, rsyns = alteredHits(r"nye_resultat\synthetic_d", "syn.+reg.+")
	psynk, psyns = alteredHits(r"nye_resultat\synthetic_d", "syn.+pwm.+")
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in hfmok:
		tTP, tFN, tFP, tTN = hfmos[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	hfmo = cc.fitness(TP, FN, FP, TN)
	
	
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in rfmok:
		tTP, tFN, tFP, tTN = rfmos[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	rfmo = cc.fitness(TP, FN, FP, TN)
	
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in pfmok:
		tTP, tFN, tFP, tTN = pfmos[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	pfmo = cc.fitness(TP, FN, FP, TN)
	
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in hfmzk:
		tTP, tFN, tFP, tTN = hfmzs[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	hfmz = cc.fitness(TP, FN, FP, TN)
	
	
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in rfmzk:
		tTP, tFN, tFP, tTN = rfmzs[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	rfmz = cc.fitness(TP, FN, FP, TN)
	
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in pfmzk:
		tTP, tFN, tFP, tTN = pfmzs[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	pfmz = cc.fitness(TP, FN, FP, TN)
	
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in hsynk:
		tTP, tFN, tFP, tTN = hsyns[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	hsyn = cc.fitness(TP, FN, FP, TN)
	
	
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in rsynk:
		tTP, tFN, tFP, tTN = rsyns[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	rsyn = cc.fitness(TP, FN, FP, TN)
	
	
	TP, FP, FN, TN = 0, 0, 0, 0
	for k in psynk:
		tTP, tFN, tFP, tTN = psyns[k][0]
		TP += tTP
		FP += tFP
		FN += tFN
		TN += tTN
	psyn = cc.fitness(TP, FN, FP, TN)
	import GraphGen as g
	input = []
	input.append({'values':[hsyn, hfmo, hfmz], 'color':'b', 'label':'MM'})
	input.append({'values':[rsyn, rfmo, rfmz], 'color':'r', 'label':'IUPAC'})
	input.append({'values':[psyn, pfmo, pfmz], 'color':'g', 'label':'PWM'})
	
	groupLabels = ["4/15", "4_of_15", "4_of_15\nzoops"]
	
	writeTableBars("c:\\figures\\figure_5.html", input, groupLabels)
	
	g.simpleBars(input,  showWindow=True, xticks = groupLabels, title=" ", xlabel=" ", ylabel="nCC", fname="c:\\figures\\final\\fig5")
	
def final_figure6(inputFolder=r"..\..\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq" + "\\", pattern = ".+fa.+"): #figure6
	files = os.listdir(inputFolder)
	files.sort()
	import re
	pattern = re.compile(pattern)
	tmp = {}
	summary = {}
	for f in files:
		path = inputFolder + f
		if os.path.isdir(path) or not pattern.match(f): continue
		
		elif not os.path.getsize(path):
			if 0 in summary: summary[0] += 1
			else: summary[0] = 1
			tmp[f] = 0
			continue
		
		fp = file(path)
		line = fp.readline()
		
		counter = 0
		while line:
			
			if line[0] in ('#','\n'):
				line = fp.readline()
				continue
			if line[0] in ('>'):
				line = fp.readline()
				continue
			
			
			while (line) and (not line[0] == '>'):
				line = fp.readline()
			counter += 1
		if counter in summary: summary[counter] += 1
		else: summary[counter] = 1
		tmp[f] = counter
	import GraphGen as g
	keys = summary.keys()
	keys.sort()
	input = []
	
	labels = []
	values = []
	
	c = 0
	for k in keys:
		if k == 0: continue
		labels.append(repr(k))
		values.append(summary[k])
		c += summary[k]
		print repr(k) + " - " + repr(summary[k])+";",
	print c - summary[0]
	
	
	input.append({'values':values, 'color':'b'})
	groupLabels = labels
	writeTableBars("c:\\figures\\figure_6.html", input, groupLabels)
	g.simpleBars(input, groupWidth=2, showWindow=True, xticks = groupLabels, title=" ", xlabel="Sequences", ylabel="Data sets", fname="c:\\figures\\final\\fig6")

#TODO: se paa alteredhits...virker merkelig
def final_figure7():
	#Real
	r_trans_hk, r_trans_hs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+hdi.+")
	r_trans_rk, r_trans_rs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+reg.+")
	r_trans_pk, r_trans_ps =  alteredHits("nye_resultat/transfac_onehit_d/", r".+pwm.+")
	
	r_trans_hk.sort()	
	r_trans_rk.sort()
	r_trans_pk.sort()
	r_trans = []
	iupacC = 0
	pwmC = 0
	tmptest = []
	for i in range(len(r_trans_hk)):
		h = cc.fitness(*r_trans_hs[r_trans_hk[i]][0])
		r = cc.fitness(*r_trans_rs[r_trans_rk[i]][0])
		p = cc.fitness(*r_trans_ps[r_trans_pk[i]][0])
		
		t = max((h, r, p))
		if t==r: iupacC += 1
		if t==p: pwmC += 1
		r_trans.append(t)
		tmptest.append((t, sum(r_trans_ps[r_trans_pk[i]][0])))
	print iupacC, pwmC
	r_trans.sort()
	tmptest.sort()
	
	tmptest = [a for b, a in tmptest]
	print float(sum(tmptest[-50:]))/50
	print float(sum(tmptest[:-50]))/len(tmptest[:-50])
	
	
	
	#Mchain, ikke ferdig resultat enda...
	
	#m_trans_hk, m_trans_hs =  alteredHits("nye_resultat/transfacmchain_onehit_d", r".+hdi.+")
	m_trans_rk, m_trans_rs =  alteredHits("nye_resultat/transfacmchain_onehit_d", r".+reg.+")
	m_trans_pk, m_trans_ps =  alteredHits("nye_resultat/transfacmchain_onehit_d", r".+pwm.+")
	
	#m_trans_hk.sort()	
	m_trans_rk.sort()
	m_trans_pk.sort()
	m_trans = []
	for i in range(len(m_trans_rk)):
		#h = cc.fitness(*m_trans_hs[m_trans_hk[i]][0])
		r = cc.fitness(*m_trans_rs[m_trans_rk[i]][0])
		p = cc.fitness(*m_trans_ps[m_trans_pk[i]][0])
		
		m_trans.append(max(( r, p)))
	m_trans.sort()
	
	#m_trans = m_trans[-50:]
	#r_trans = r_trans[-50:]
	
	
	import GraphGen as gg
	
	input = []
	linetype = gg.SIMPLE
	input.append({'x':range(len(r_trans)), 'y':r_trans, 'type':linetype,\
						'lineproperties':{'label':'Real Transfac', 'marker':'.', 'linewidth':1, 'color':'r',\
						'markerfacecolor':'r'}})
	input.append({'x':range(len(m_trans)), 'y':m_trans, 'type':linetype,\
						'lineproperties':{'label':'Markov Transfac', 'marker':'.', 'linewidth':1, 'color':'g',\
						'markerfacecolor':'g'}})
				
	writeTableLines("c:\\figures\\figur_7.html", input)
	
	gg.simplePlot(input, axis=[0, len(r_trans), 0, 1.1], title=" ", xlabel=" ", ylabel="nCC", fname="C:\\figures\\final\\fig7", showWindow = True)

def final_figure8(): #figure8
	##Tompa
	
	r_tompa_hk, r_tompa_hs =  alteredHits("nye_resultat/tompa_d/real/", r".+hdi.+")
	r_tompa_rk, r_tompa_rs =  alteredHits("nye_resultat/tompa_d/real/", r".+reg.+")
	r_tompa_pk, r_tompa_ps =  alteredHits("nye_resultat/tompa_d/real/", r".+pwm.+")
	
	r_tompa_hk.sort()	
	r_tompa_rk.sort()
	r_tompa_pk.sort()
	r_tompas = []
	for i in range(len(r_tompa_hk)):
		h = cc.fitness(*r_tompa_hs[r_tompa_hk[i]][0])
		r = cc.fitness(*r_tompa_rs[r_tompa_rk[i]][0])
		p = cc.fitness(*r_tompa_ps[r_tompa_pk[i]][0])
		
		r_tompas.append(max((h, r, p)))
	r_tompas.sort()
	
	
	#Mchain
	
	m_tompa_hk, m_tompa_hs =  alteredHits("nye_resultat/tompa_d/mchain/", r".+hdi.+")
	m_tompa_rk, m_tompa_rs =  alteredHits("nye_resultat/tompa_d/mchain/", r".+reg.+")
	m_tompa_pk, m_tompa_ps =  alteredHits("nye_resultat/tompa_d/mchain/", r".+pwm.+")
	
	m_tompa_hk.sort()	
	m_tompa_rk.sort()
	m_tompa_pk.sort()
	m_tompas = []
	for i in range(len(m_tompa_rk)):
		h = cc.fitness(*m_tompa_hs[m_tompa_hk[i]][0])
		r = cc.fitness(*m_tompa_rs[m_tompa_rk[i]][0])
		p = cc.fitness(*m_tompa_ps[m_tompa_pk[i]][0])
		
		m_tompas.append(max((h, r, p)))
	m_tompas.sort()
	
	m_tompas = m_tompas[-50:]
	r_tompas = r_tompas[-50:]
	
	
	
	
	##Transfac
	#Real
	r_trans_hk, r_trans_hs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+hdi.+")
	r_trans_rk, r_trans_rs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+reg.+")
	r_trans_pk, r_trans_ps =  alteredHits("nye_resultat/transfac_onehit_d/", r".+pwm.+")
	
	r_trans_hk.sort()	
	r_trans_rk.sort()
	r_trans_pk.sort()
	r_trans = []
	for i in range(len(r_trans_hk)):
		h = cc.fitness(*r_trans_hs[r_trans_hk[i]][0])
		r = cc.fitness(*r_trans_rs[r_trans_rk[i]][0])
		p = cc.fitness(*r_trans_ps[r_trans_pk[i]][0])
		
		r_trans.append(max((h, r, p)))
	r_trans.sort()
	
	
	#Mchain, ikke ferdig resultat enda...
	
	#m_trans_hk, m_trans_hs =  alteredHits("nye_resultat/transfacmchain_onehit_d", r".+hdi.+")
	m_trans_rk, m_trans_rs =  alteredHits("nye_resultat/transfacmchain_onehit_d", r".+reg.+")
	m_trans_pk, m_trans_ps =  alteredHits("nye_resultat/transfacmchain_onehit_d", r".+pwm.+")
	
	#m_trans_hk.sort()	
	m_trans_rk.sort()
	m_trans_pk.sort()
	m_trans = []
	for i in range(len(m_trans_rk)):
		#h = cc.fitness(*m_trans_hs[m_trans_hk[i]][0])
		r = cc.fitness(*m_trans_rs[m_trans_rk[i]][0])
		p = cc.fitness(*m_trans_ps[m_trans_pk[i]][0])
		
		m_trans.append(max(( r, p)))
	m_trans.sort()
	
	print m_trans[-51:-48]
	print r_trans[-51:-48]
	m_trans = m_trans[-50:]
	
	r_trans = r_trans[-50:]
	
	
	import GraphGen as gg
	
	input = []
	linetype = gg.SIMPLE
	input.append({'x':range(len(r_trans)), 'y':r_trans, 'type':linetype,\
						'lineproperties':{'label':'Real Transfac', 'marker':'.', 'linewidth':1, 'color':'r',\
						'markerfacecolor':'r'}})
	input.append({'x':range(len(m_trans)), 'y':m_trans, 'type':linetype,\
						'lineproperties':{'label':'Markov Transfac', 'marker':'.', 'linewidth':1, 'color':'g',\
						'markerfacecolor':'g'}})
	
	
	
	input.append({'x':range(len(r_tompas)), 'y':r_tompas, 'type':linetype,\
						'lineproperties':{'label':'Real Tompa', 'marker':'.', 'linewidth':1, 'color':'y',\
						'markerfacecolor':'y'}})
	input.append({'x':range(len(m_tompas)), 'y':m_tompas, 'type':linetype,\
						'lineproperties':{'label':'Markov Tompa', 'marker':'.', 'linewidth':1, 'color':'b',\
						'markerfacecolor':'b'}})
	
	writeTableLines("c:\\figures\\figur_8.html", input)
	
	gg.simplePlot(input, axis=[0, len(r_tompas), 0, 1.1], title=" ", xlabel=" ", ylabel="nCC", fname="C:\\figures\\final\\fig8", showWindow = True)

def figureAa():
	#Husk aa forandre funksjon etter om man skal ha en hit per sekvens eller alle
	
	tf = tf_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq",r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\zoops_known_l_out", ".+fas", cc.fitness)
	tf_unk = tf_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq",r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\zoops_unknown_l_out", ".+fas", cc.fitness)

	tm = tm_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\tompa05assesing\real", r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\tompa05assesing\real\mwgiven_out", ".+fasta", cc.fitness)
	tm_unk = tm_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\tompa05assesing\real", r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\tompa05assesing\real\out", ".+fasta", cc.fitness)
	
	
	#Finne order
	hk, hs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+hdi.+")
	rk, rs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+reg.+")
	pk, ps =  alteredHits("nye_resultat/transfac_onehit_d/", r".+pwm.+")
	hk.sort()
	rk.sort()
	pk.sort()
	
	best = []
	for i in range(len(hk)):
		h = cc.fitness(*hs[hk[i]][0])
		r = cc.fitness(*rs[rk[i]][0])
		p = cc.fitness(*ps[pk[i]][0])
		
		best.append((max((h, r, p)), hk[i][:hk[i].find("_-_")]))
	best.sort()
	
	bestkeys = [a for b,a in best[-50:]]
	
	
	
	
	
	TP, FP, FN, TN = 0,0,0,0
	#for k in tf:
	for k in bestkeys:
		tTP, tFN, tFP, tTN = tf[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_score = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0,0,0,0
	#for k in tf_unk:
	for k in bestkeys:
		tTP, tFN, tFP, tTN = tf_unk[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_unk_score = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0,0,0,0
	for k in tm:
		tTP, tFN, tFP, tTN = tm[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tm_score = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0,0,0,0
	for k in tm_unk:
		tTP, tFN, tFP, tTN = tm_unk[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tm_unk_score = cc.fitness(TP, FN, FP, TN)
	
	"""
	#import pickle as p
	#r = p.load(file("results.dict"))["MEME"]
	TP, FP, FN, TN = 0,0,0,0
	for null, tTP, tFN, tFP, tTN in r:
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tompa_score = cc.fitness(TP, FN, FP, TN)
	"""
	
	
	import GraphGen as g
	
	input = []
	
	#input.append({'values':[tf_unk_score, tf_score, 0], 'label':'Transfac'})
	#input.append({'values':[tm_unk_score, tm_score, tompa_score], 'color':'r', 'label':'Tompa'})
	#groupLabels = ["Unknown_l", "Known_l", "From_article"]
	print tf_unk_score, tf_score, tm_unk_score, tm_score
	#0.0904131659961 0.125639747165 0.00847413443981 0.0116645916004
	input.append({'values':[tf_unk_score, tf_score], 'label':'Transfac'})
	input.append({'values':[tm_unk_score, tm_score], 'color':'r', 'label':'Tompa'})
	
	groupLabels = ["Unknown_l", "Known_l"]
	#print tompa_score
	
	
	writeTableBars("c:\\figures\\figure_Aa_best.html", input, groupLabels)
	
	g.simpleBars(input, yaxis=[0, 1.1], showWindow=True, xticks = groupLabels, title="figur_Aa_best", xlabel="Groups", ylabel="Accumulated CC", fname="c:\\figures\\*")
	
	
def figureAb():
	#Husk aa forandre funksjon etter om man skal ha en hit per sekvens eller alle
	
	tf = tf_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\mchain",r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\mchain\zoops_known_l_out", ".+fas", cc.fitness)
	tf_unk = tf_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\mchain",r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\mchain\zoops_unknown_l_out", ".+fas", cc.fitness)

	tm = tm_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\tompa05assesing\mchain", r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\tompa05assesing\mchain\mwgiven_out", ".+fasta", cc.fitness)
	tm_unk = tm_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\tompa05assesing\mchain", r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\tompa05assesing\mchain\out", ".+fasta", cc.fitness)
	
	#Finne beste av de tre, mchain hdist mangler
	
	#hk, hs =  alteredHits("nye_resultat/transfacmchain_onehit_d/", r".+hdi.+")
	rk, rs =  alteredHits("nye_resultat/transfacmchain_onehit_d/", r".+reg.+")
	pk, ps =  alteredHits("nye_resultat/transfacmchain_onehit_d/", r".+pwm.+")
	#hk.sort()
	rk.sort()
	pk.sort()
	
	best = []
	for i in range(len(rk)):
		#h = cc.fitness(*hs[hk[i]][0])
		r = cc.fitness(*rs[rk[i]][0])
		p = cc.fitness(*ps[pk[i]][0])
		
		best.append((max(( r, p)), rk[i][:rk[i].find("_-_")]))
	best.sort()
	
	bestkeys = [a for b,a in best[-50:]]
	
	
	TP, FP, FN, TN = 0,0,0,0
	#for k in tf:
	for k in bestkeys:
		tTP, tFN, tFP, tTN = tf[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_score = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0,0,0,0
	#for k in tf_unk:
	for k in bestkeys:
		tTP, tFN, tFP, tTN = tf_unk[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_unk_score = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0,0,0,0
	for k in tm:
		tTP, tFN, tFP, tTN = tm[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tm_score = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0,0,0,0
	for k in tm_unk:
		tTP, tFN, tFP, tTN = tm_unk[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tm_unk_score = cc.fitness(TP, FN, FP, TN)
	
	"""
	import pickle as p
	r = p.load(file("results.dict"))["MEME"]
	
	TP, FP, FN, TN = 0,0,0,0
	for null, tTP, tFN, tFP, tTN in r:
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tompa_score = cc.fitness(TP, FN, FP, TN)
	"""
	
	
	import GraphGen as g
	
	input = []
	
	#input.append({'values':[tf_unk_score, tf_score, 0], 'label':'Transfac'})
	#input.append({'values':[tm_unk_score, tm_score, tompa_score], 'color':'r', 'label':'Tompa'})
	#groupLabels = ["Unknown_l", "Known_l", "From_article"]
	print tf_unk_score, tf_score, tm_unk_score, tm_score
	#0.295327005997 0.366673754591 0.0757239845488 0.0655011325832
	#0.30831851739 0.378206525447 0.07603550286 0.0655011325832
	input.append({'values':[tf_unk_score, tf_score], 'label':'Transfac'})
	input.append({'values':[tm_unk_score, tm_score], 'color':'r', 'label':'Tompa'})
	
	groupLabels = ["Unknown_l", "Known_l"]
	#print tompa_score
	
	

	writeTableBars("c:\\figures\\figure_Ab_best.html", input, groupLabels)
	g.simpleBars(input, yaxis=[0, 1.1], showWindow=True, xticks = groupLabels, title="figur_Ab_best", xlabel="Groups", ylabel="Accumulated CC", fname="c:\\figures\\*")
	
	
def figureBa():
	tf = tf_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq",r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\zoops_known_l_out", ".+fas", cc.fitness)
	tf_unk = tf_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq",r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\zoops_unknown_l_out", ".+fas", cc.fitness)
	
	#Finne beste av de tre
	hk, hs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+hdi.+")
	rk, rs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+reg.+")
	pk, ps =  alteredHits("nye_resultat/transfac_onehit_d/", r".+pwm.+")
	hk.sort()
	rk.sort()
	pk.sort()
	
	best = []
	for i in range(len(hk)):
		h = cc.fitness(*hs[hk[i]][0])
		r = cc.fitness(*rs[rk[i]][0])
		p = cc.fitness(*ps[pk[i]][0])
		
		best.append((max((h, r, p)), hk[i][:hk[i].find("_-_")]))
	best.sort()
	
	bestkeys, restkeys = [a for b,a in best[-50:]], [a for b,a in best[:-50]]
	
	
	
	TP, FP, FN, TN = 0,0,0,0
	for k in bestkeys:
		tTP, tFN, tFP, tTN = tf[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_best = cc.fitness(TP, FN, FP, TN)
	
	
	TP, FP, FN, TN = 0,0,0,0
	for k in bestkeys:
		tTP, tFN, tFP, tTN = tf_unk[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_unk_best = cc.fitness(TP, FN, FP, TN)
	
	
	TP, FP, FN, TN = 0,0,0,0
	for k in restkeys:
		tTP, tFN, tFP, tTN = tf[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_rest = cc.fitness(TP, FN, FP, TN)
	
	
	TP, FP, FN, TN = 0,0,0,0
	for k in restkeys:
		tTP, tFN, tFP, tTN = tf_unk[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_unk_rest = cc.fitness(TP, FN, FP, TN)
	
	
	import GraphGen as g
	
	input = []
	
	input.append({'values':[tf_unk_best, tf_best], 'label':'50 Best'})
	input.append({'values':[tf_unk_rest, tf_rest], 'color':'r', 'label':'Rest'})
	
	
	
	groupLabels = ["Unknown_l", "Known_l"]

	#writeTableBars("c:\\figures\\figure_Ba.html", input, groupLabels)
	print input
	g.simpleBars(input, yaxis=[0, 1.1], showWindow=True, xticks = groupLabels, title="figur_Ba", xlabel="Groups", ylabel="Accumulated CC", fname="c:\\figures\\*")
	
		
		
def figureBb():
	tf = tf_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\mchain",r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\mchain\zoops_known_l_out", ".+fas", cc.fitness)
	tf_unk = tf_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\mchain",r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\mchain\zoops_unknown_l_out", ".+fas", cc.fitness)
	
	#Finne beste av de tre, mchain hdist mangler
	
	#hk, hs =  alteredHits("nye_resultat/transfacmchain_onehit_d/", r".+hdi.+")
	rk, rs =  alteredHits("nye_resultat/transfacmchain_onehit_d/", r".+reg.+")
	pk, ps =  alteredHits("nye_resultat/transfacmchain_onehit_d/", r".+pwm.+")
	#hk.sort()
	rk.sort()
	pk.sort()
	
	best = []
	for i in range(len(rk)):
		#h = cc.fitness(*hs[hk[i]][0])
		r = cc.fitness(*rs[rk[i]][0])
		p = cc.fitness(*ps[pk[i]][0])
		
		best.append((max(( r, p)), rk[i][:rk[i].find("_-_")]))
	best.sort()
	
	bestkeys, restkeys = [a for b,a in best[-50:]], [a for b,a in best[:-50]]
	
	
	
	TP, FP, FN, TN = 0,0,0,0
	for k in bestkeys:
		tTP, tFN, tFP, tTN = tf[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_best = cc.fitness(TP, FN, FP, TN)
	
	
	TP, FP, FN, TN = 0,0,0,0
	for k in bestkeys:
		tTP, tFN, tFP, tTN = tf_unk[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_unk_best = cc.fitness(TP, FN, FP, TN)
	
	
	TP, FP, FN, TN = 0,0,0,0
	for k in restkeys:
		tTP, tFN, tFP, tTN = tf[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_rest = cc.fitness(TP, FN, FP, TN)
	
	
	TP, FP, FN, TN = 0,0,0,0
	for k in restkeys:
		tTP, tFN, tFP, tTN = tf_unk[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_unk_rest = cc.fitness(TP, FN, FP, TN)
	
	
	import GraphGen as g
	
	input = []
	
	input.append({'values':[tf_unk_best, tf_best], 'label':'50 Best'})
	input.append({'values':[tf_unk_rest, tf_rest], 'color':'r', 'label':'Rest'})
	
	
	
	groupLabels = ["Unknown_l", "Known_l"]

	#writeTableBars("c:\\figures\\figure_Bb.html", input, groupLabels)
	print input
	g.simpleBars(input, yaxis=[0, 1.1], showWindow=True, xticks = groupLabels, title="figur_Bb", xlabel="Groups", ylabel="Accumulated CC", fname="c:\\figures\\*")
		
	
	
	
	
def figureC():
	#Husk aa forandre funksjon etter om man skal ha en hit per sekvens eller alle
	#MEME
	tf_r = tf_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq",r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\zoops_known_l_out", ".+fas", cc.fitness)
	tf_r_u = tf_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq",r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\zoops_unknown_l_out", ".+fas", cc.fitness)
	
	
	tf_m = tf_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\mchain",r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\mchain\zoops_known_l_out", ".+fas", cc.fitness)
	tf_m_u = tf_getScoreNucleotideLevel(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\mchain",r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\transfac\noIUPAC\nc_sequences\noshort\no_d_seq\uniqueids\end_truncated\min_five_seq\mchain\zoops_unknown_l_out", ".+fas", cc.fitness)

	#Finne beste av de tre, Real
	hk, hs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+hdi.+")
	rk, rs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+reg.+")
	pk, ps =  alteredHits("nye_resultat/transfac_onehit_d/", r".+pwm.+")
	hk.sort()
	rk.sort()
	pk.sort()
	
	best = []
	for i in range(len(hk)):
		h = cc.fitness(*hs[hk[i]][0])
		r = cc.fitness(*rs[rk[i]][0])
		p = cc.fitness(*ps[pk[i]][0])
		
		best.append((max((h, r, p)), hk[i][:hk[i].find("_-_")]))
	best.sort()
	
	real_bestkeys = [a for b,a in best[-50:]]
	
	#Finne beste av de tre, Mchain,  hdist mangler
	
	#hk, hs =  alteredHits("nye_resultat/transfacmchain_onehit_d/", r".+hdi.+")
	rk, rs =  alteredHits("nye_resultat/transfacmchain_onehit_d/", r".+reg.+")
	pk, ps =  alteredHits("nye_resultat/transfacmchain_onehit_d/", r".+pwm.+")
	#hk.sort()
	rk.sort()
	pk.sort()
	
	best = []
	for i in range(len(rk)):
		#h = cc.fitness(*hs[hk[i]][0])
		r = cc.fitness(*rs[rk[i]][0])
		p = cc.fitness(*ps[pk[i]][0])
		
		best.append((max(( r, p)), rk[i][:rk[i].find("_-_")]))
	best.sort()
	
	mchain_bestkeys = [a for b,a in best[-50:]]
	
	
	
	TP, FP, FN, TN = 0,0,0,0
	#for k in tf_r:
	for k in real_bestkeys:
		tTP, tFN, tFP, tTN = tf_r[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_r_score = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0,0,0,0
	#for k in tf_r_u:
	for k in real_bestkeys:
		tTP, tFN, tFP, tTN = tf_r_u[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_r_u_score = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0,0,0,0
	#for k in tf_m:
	for k in mchain_bestkeys:
		tTP, tFN, tFP, tTN = tf_m[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_m_score = cc.fitness(TP, FN, FP, TN)
	
	TP, FP, FN, TN = 0,0,0,0
	#for k in tf_m_u:
	for k in mchain_bestkeys:
		tTP, tFN, tFP, tTN = tf_m_u[k][1:]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	tf_m_u_score = cc.fitness(TP, FN, FP, TN)
	
	#Benchmark scores
	hk, hs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+hdi.+")
	rk, rs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+reg.+")
	pk, ps =  alteredHits("nye_resultat/transfac_onehit_d/", r".+pwm.+")
	#hmk, hms =  alteredHits("nye_resultat/transfacmchain_onehit_d/", r".+hdi.+")
	rmk, rms =  alteredHits("nye_resultat/transfacmchain_onehit_d/", r".+reg.+")
	pmk, pms =  alteredHits("nye_resultat/transfacmchain_onehit_d/", r".+pwm.+")
	#hk.sort()
	rk.sort()
	pk.sort()
	
	TP, FP, FN, TN = 0,0,0,0
	for i in range(len(hk)):
		
		tmp = {}
		tmp[cc.fitness(*hs[hk[i]][0])] = hs[hk[i]][0]
		tmp[cc.fitness(*rs[rk[i]][0])] = rs[rk[i]][0]
		tmp[cc.fitness(*ps[pk[i]][0])] = ps[pk[i]][0]
		
		tTP, tFN, tFP, tTN = tmp[max(tmp.keys())]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	dr = cc.fitness(TP, FN, FP, TN)
	print dr
	TP, FP, FN, TN = 0,0,0,0
	
	
	for i in range(len(rmk)):
		tmp = {}
		#tmp[cc.fitness(*hms[hmk[i]][0])] = hms[hmk[i]][0]
		tmp[cc.fitness(*rms[rmk[i]][0])] = rms[rmk[i]][0]
		tmp[cc.fitness(*pms[pmk[i]][0])] = pms[pmk[i]][0]
		
		tTP, tFN, tFP, tTN = tmp[max(tmp.keys())]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	dmr = cc.fitness(TP, FN, FP, TN)
	
	#print dmr
	
	import GraphGen as gg
	input = []
	
	input.append({'values':[tf_r_score, tf_r_u_score, dr], 'color':'b', 'label':'Real'})
	input.append({'values':[tf_m_score, tf_m_u_score, dmr], 'color':'r', 'label':'Mchain'})
	
	print input
	groupLabels = ["MEME-known_l", "MEME-unknown_l", "Discrimination"]
	writeTableBars("c:\\figures\\figure_C_new.html", input, groupLabels)
		
	gg.simpleBars(input, yaxis=[0, 1.1], showWindow=True, xticks = groupLabels, title="figur_C_new", xlabel="", ylabel="Average CC", fname="c:\\figures\\*")
	
	#Markov chain:
	#Best:0.77676835341
	#PWM: 0.721190813344
	#IUPAC: 0.740220840311
	
	#Real:
	#Best: 0.66986348696
	#PWM: 0.61947429794
	#IUPAC: 0.675312325559

def final_figure4(): #figureD
	import pickle as p
	r = p.load(file("results.dict"))
	print r.keys()
	
	
	r=r["MEME"]
	r = dict((name, (TP, FN, FP, TN)) for name, TP, FN, FP, TN in r)
		
	
	
	pwgk, pwgs = alteredHits("added/generic/pwm", ".+res")
	pwmk, pwms = alteredHits("added/mchain/pwm", ".+res")
	pwrk, pwrs = alteredHits("added/real/pwm", ".+res")
	
	regk, regs = alteredHits("added/generic/reg", ".+res")
	remk, rems = alteredHits("added/mchain/reg", ".+res")
	rerk, rers = alteredHits("added/real/reg", ".+res")
	
	hdgk, hdgs = alteredHits("added/generic/hdi", ".+res")
	hdmk, hdms = alteredHits("added/mchain/hdi", ".+res")
	hdrk, hdrs = alteredHits("added/real/hdi", ".+res")
	
	
	
	
	disckeys = pwgk + pwmk + pwrk + regk + remk + rerk + hdgk + hdmk + hdrk
	#disckeys = pwgk + pwmk + pwrk
	keys = r.keys()
	
	
	connection = {}
	discarded = []
	for k in keys:
		tmp = []
		for dk in disckeys:
			if k in dk: tmp.append(dk)
		if tmp: connection[k] = tmp
		else:discarded.append(k)
	
	layout = []
	for k in connection:
		pwmkey, regkey, hdikey = connection[k]
		#pwmkey = connection[k][0]
		
		if k[-1] == "g":
			
			tp = cc.fitness(*pwgs[pwmkey][0])
			tr = cc.fitness(*regs[regkey][0])
			th = cc.fitness(*hdgs[hdikey][0])
			
			
			layout.append((max((tp, tr, th)), k))
		elif k[-1] == "m":

			tp = cc.fitness(*pwms[pwmkey][0])
			tr = cc.fitness(*rems[regkey][0])
			th = cc.fitness(*hdms[hdikey][0])
			
			
			layout.append((max((tp, tr, th)), k))
		elif k[-1] == "r":

			tp = cc.fitness(*pwrs[pwmkey][0])
			tr = cc.fitness(*rers[regkey][0])
			th = cc.fitness(*hdrs[hdikey][0])
			
			
			layout.append((max((tp, tr, th)), k))
	layout.sort()
	order = [a for b, a in layout]
	invorder = order[:]
	invorder.reverse()
	
	TP, FN, FP, TN = 0, 0, 0, 0
	for k in order:
		tTP, tFN, tFP, tTN = r[k]
		TP += tTP
		FP += tFP
		TN += tTN
		FN += tFN
	
	TPFNFPTN = TP, FN, FP, TN
	
	
	remove_predictions = []
	for k in order:
		remove_predictions.append(cc.fitness(TP, FN, FP, TN))
		tTP, tFN, tFP, tTN = r[k]
		TP -= tTP
		FN += tTP
		FP -= tFP
		TN += tFP
	remove_predictions.append(cc.fitness(TP, FN, FP, TN))
	
	
	
	TP, FN, FP, TN = TPFNFPTN
	
	remove_hardsets = []
	for k in order:
		
		remove_hardsets.append(cc.fitness(TP, FN, FP, TN))
		tTP, tFN, tFP, tTN = r[k]
		TP -= tTP
		FN -= tFN
		FP -= tFP
		TN -= tTN
	
		
	remove_hardsets.append(0.0)
	
		
	TP, FN, FP, TN = TPFNFPTN
	
	remove_easysets = []
	for k in invorder:
		
		remove_easysets.append(cc.fitness(TP, FN, FP, TN))
		tTP, tFN, tFP, tTN = r[k]
		TP -= tTP
		FN -= tFN
		FP -= tFP
		TN -= tTN
	
		
	remove_easysets.append(0.0)
		
	
	
	
	import GraphGen as gg
	
	input = []
	linetype = gg.SIMPLE
	
	
	
	
	input.append({'x':range(len(remove_predictions)), 'y':remove_predictions, 'type':linetype,\
						'lineproperties':{'label':'Erase hard predictions', 'marker':'.', 'linewidth':1, 'color':'g',\
						'markerfacecolor':'g'}})
	input.append({'x':range(len(remove_hardsets)), 'y':remove_hardsets, 'type':linetype,\
						'lineproperties':{'label':'Remove hard sets', 'marker':'.', 'linewidth':1, 'color':'b',\
						'markerfacecolor':'b'}})
	input.append({'x':range(len(remove_easysets)), 'y':remove_easysets, 'type':linetype,\
						'lineproperties':{'label':'Remove easy sets', 'marker':'.', 'linewidth':1, 'color':'r',\
						'markerfacecolor':'r'}})
						
	writeTableLines("c:\\figures\\max.html", input)
	gg.simplePlot(input, axis=[0,30,0,0.2],title=" ", xlabel=" ", ylabel="nCC", fname="C:\\figures\\final\\fig4", showWindow = True)
	
def final_scatterA(): 
	
	
	r_trans_hk, r_trans_hs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+hdi.+")
	r_trans_rk, r_trans_rs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+reg.+")
	r_trans_pk, r_trans_ps =  alteredHits("nye_resultat/transfac_onehit_d/", r".+pwm.+")
	
	
	r_trans_hk.sort()	
	r_trans_rk.sort()
	r_trans_pk.sort()
	connection = {}
	for i in range(len(r_trans_hk)):
		h = cc.fitness(*r_trans_hs[r_trans_hk[i]][0])
		r = cc.fitness(*r_trans_rs[r_trans_rk[i]][0])
		p = cc.fitness(*r_trans_ps[r_trans_pk[i]][0])
		
		t = max((h, r, p))
		connection[r_trans_hk[i].split("_-_")[0]] = t
	
	scores, sites, dnames = [], [], []
	for d in getAllFTransfac():
		score = connection[d._filename]
		site = len(d.getMotifWindows())
		
		
		
		scores.append(score)
		sites.append(site)
		dnames.append(d._filename)
	
	import GraphGen as g
	input = []
	input.append({'x':sites, 'y':scores, 'c':"#ffaa00", "m":"s"})
	
	
	g.scatter(input, showWindow=True, axis=[0, 82, 0, 1], title=" ", xlabel="Binding sites", ylabel="nCC", fname="c:\\figures\\final\\scatter_25___asdsadasd")



def scatterB():
	
	"""
	r_trans_hk, r_trans_hs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+hdi.+")
	r_trans_rk, r_trans_rs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+reg.+")
	r_trans_pk, r_trans_ps =  alteredHits("nye_resultat/transfac_onehit_d/", r".+pwm.+")
	r_trans_hk.sort()	
	r_trans_rk.sort()
	r_trans_pk.sort()
	connection = {}
	for i in range(len(r_trans_hk)):
		h = cc.fitness(*r_trans_hs[r_trans_hk[i]][0])
		r = cc.fitness(*r_trans_rs[r_trans_rk[i]][0])
		p = cc.fitness(*r_trans_ps[r_trans_pk[i]][0])
		
		t = max((h, r, p))
		connection[r_trans_hk[i].split("_-_")[0]] = t
	"""
	
	r_trans_pk, r_trans_ps =  alteredHits("nye_resultat/lowbatch_removed_d/", r".+pwm.+")
	r_trans_rk, r_trans_rs =  alteredHits("nye_resultat/lowbatch_removed_d/", r".+reg.+")
	r_trans_pk.sort()
	r_trans_rk.sort()
	
	connection = {}
	j = 0
	
	for i in range(len(r_trans_pk)):
		p = cc.fitness(*r_trans_ps[r_trans_pk[i]][0])
		r = cc.fitness(*r_trans_rs[r_trans_rk[j]][0])
		print j
		print r_trans_pk[i]
		if r_trans_pk[i].find("M00932.fas") > -1:
			
			r = 0
		else:
			j+=1
		
		connection[r_trans_pk[i].split("_-_")[0]] = max((r, p))
	
	
	scores, sites, dnames = [], [], []
	for d in getAllFTransfac():
		if d._filename in ("M01032.fas", "M01033.fas"): continue
		score = connection[d._filename]
		site = len(d.getMotifWindows())
		
		scores.append(score)
		sites.append(site)
		dnames.append(d._filename)
	
	import GraphGen as g
	input = []
	#input.append({'x':sites, 'y':scores, 'c':"#ffaa00", "m":"s"})
	
	
	#g.scatter(input, showWindow=True, axis=[0, 82, 0, 1], title="Scatter_25_ny_nyscore_opt", xlabel="sites", ylabel="cc", fname="c:\\*")
	scores.sort()
	print scores
	linetype = g.SIMPLE
	input.append({'x':range(len(scores)), 'y':scores, 'type':linetype,\
						'lineproperties':{'label':'Best_of_3', 'marker':'.', 'linewidth':1, 'color':'g',\
						'markerfacecolor':'g'}})
	print input
	writeTableLines("c:\\scatter_filtered.png", input)
	
	g.simplePlot(input, axis=[0, len(scores), 0, 1.1], title="scatter_filtered", xlabel=" ", ylabel="CC", fname="C:\\*", showWindow = True)

	
	
def final_scatterC():
	
	
	
	
	
	r_trans_hk, r_trans_hs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+hdi.+")
	r_trans_rk, r_trans_rs =  alteredHits("nye_resultat/transfac_onehit_d/", r".+reg.+")
	r_trans_pk, r_trans_ps =  alteredHits("nye_resultat/transfac_onehit_d/", r".+pwm.+")
	r_trans_ok, r_trans_os =  alteredHits("nye_resultat/lowbatch_d/", r".+opt.+")
	pool = [k.split("_-_")[0] for k in r_trans_ok]
	
	
	r_trans_hk.sort()
	r_trans_rk.sort()
	r_trans_pk.sort()
	r_trans_ok.sort()
	

	
	
	connection = {}
	for i in range(len(r_trans_hk)):
		if r_trans_hk[i].split("_-_")[0] not in pool: continue
		h = cc.fitness(*r_trans_hs[r_trans_hk[i]][0])
		r = cc.fitness(*r_trans_rs[r_trans_rk[i]][0])
		p = cc.fitness(*r_trans_ps[r_trans_pk[i]][0])
		
		t = max((h, r, p))
		connection[r_trans_hk[i].split("_-_")[0]] = t
	optimal = []
	print r_trans_ok
	for k in r_trans_ok:
		optimal.append(cc.fitness(*r_trans_os[k][0]))
	discscores = []
	
	r_trans_hk = connection.keys()
	r_trans_hk.sort()
	print r_trans_hk
	for k in r_trans_hk:
		discscores.append(connection[k])


	import GraphGen as gg
	
	input = []
	linetype = gg.SIMPLE
	
	optimal.sort()
	discscores.sort()
	
	input.append({'x':range(len(optimal)), 'y':optimal, 'type':linetype,\
						'lineproperties':{'label':'Bound for no-context models', 'marker':'.', 'linewidth':1, 'color':'r',\
						'markerfacecolor':'r'}})
	input.append({'x':range(len(discscores)), 'y':discscores, 'type':linetype,\
						'lineproperties':{'label':'Best of the three common models', 'marker':'.', 'linewidth':1, 'color':'g',\
						'markerfacecolor':'g'}})
	print input
	writeTableLines("c:\\lowbatch_sorted_d.png", input)
	
	gg.simplePlot(input, axis=[0, len(optimal), 0, 1.1], title=" ", xlabel=" ", ylabel="nCC", fname="C:\\figures\\final\\lowbatch_d", showWindow = True)

	
def scatterD():
	
	
	
	r_trans_ok, r_trans_os =  alteredHits("nye_resultat/lowbatch_d/", r".+opt.+")

	r_trans_ok.sort()
	
	connection = {}
	j = 0
	
	for i in range(len(r_trans_ok)):
		o = cc.fitness(*r_trans_os[r_trans_ok[i]][0])

		
		
		connection[r_trans_ok[i].split("_-_")[0]] = o
	
	
	scores, sites, dnames = [], [], []
	for d in getAllFTransfac():
		score = connection[d._filename]
		site = len(d.getMotifWindows())
		
		scores.append(score)
		sites.append(site)
		dnames.append(d._filename)
	
	import GraphGen as g
	input = []
	input.append({'x':sites, 'y':scores, 'c':"#ffaa00", "m":"s"})
	
	
	g.scatter(input, showWindow=True, axis=[0, 82, 0, 1], title="Scatter_25_opt", xlabel="sites", ylabel="cc", fname="c:\\*")
	
	
	
def main():
	#figureC()
	#final_scatterA()
	figureAb()
	#final_figure8()
	0.794

if __name__ == "__main__":
	main()
	
	"""
	
	a, b = alteredHits("nye_resultat/transfac_onehit_d/", ".+reg.+")
	
	c = 0
	for k in a:
		print b[k]
		c += (cc.fitness(*b[k][1]) - cc.fitness(*b[k][0]))
	c /= len(a)
	print c
	"""

	
	

def _getSeqLen(fileName):
	fp = file(fileName)
	
	seq_id = ""
	seq = ""
	outputList = []
	line = fp.readline()
	res = []
	while line:
		if line[0] in ('#','\n'):
			seq += line
			line = fp.readline()
			continue
		if line[0] in ('>'):
			seq += line
			seq_id = line.strip()
			
			line = fp.readline()
			continue
		tmp = ""
		while (line) and (not line[0] == '>'):
			
			tmp += line.strip()
			line = fp.readline()
		
		res.append(len(tmp))
		
		
		seq = ""
	
	fp.close()
	return res

def __alteredToStd(input):
	return cc.fitness(*input[0])


"""
null, orscores = getResultAttributes("a/", ".+fas", "score")
null, mcscores = getResultAttributes("b/", ".+fas", "score")


s1, s2 = [], []
for k in null:
	s1.append(orscores[k][0])
	s2.append(mcscores[k][0])
	
s1.sort()
s2.sort()
import GraphGen as gg

input = []
input.append({'x':range(len(s1)), 'y':s1, 'type':gg.SPLINE,\
					'lineproperties':{'label':'Real', 'marker':'.', 'linewidth':1, 'color':'b',\
					'markerfacecolor':'b'}})
input.append({'x':range(len(s2)), 'y':s2, 'type':gg.SPLINE,\
					'lineproperties':{'label':'Mchain', 'marker':'.', 'linewidth':1, 'color':'r',\
					'markerfacecolor':'r'}})
					
gg.simplePlot(input, title="Real_vs_mchain", xlabel=" ", ylabel="CC", fname="C:\\temp\\*")
"""


"""
keys, hits = alteredHits("added\\generic\\hdi\\", ".+res$")
null, hdi, hdiold = averageChangeInScoringFunction(sf.wcc(0).fitness, hits, keys)

keys, hits = alteredHits("added\\generic\\reg\\", ".+res$")
null, reg, regold = averageChangeInScoringFunction(sf.wcc(0).fitness, hits, keys)

keys, hits = alteredHits("added\\generic\\pwm\\", ".+res$")
null, pwm, pwmold = averageChangeInScoringFunction(sf.wcc(0).fitness, hits, keys)
keys, hits = alteredHits("added\\generic\\opt\\", ".+res$")
null, opt, optold = averageChangeInScoringFunction(sf.wcc(0).fitness, hits, keys)

import GraphGen as gg
input = []
input.append({'values':[hdi, reg, pwm, opt], 'color':'r', 'label':'New'})
input.append({'values':[hdiold, regold, pwmold, optold], 'color':'b', 'label':'Old'})


groupLabels = ["Hamming distance", "IUPAC", "PWM", "Optimal"]


gg.simpleBars(input, showWindow=True, xticks = groupLabels, fname="c:\\*", title="Change_Generic_Tompa", xlabel=" ", ylabel="Correlation Coefficient")
"""


"""
rootfolder = OBJECTFOLDER+"added\\tba\\Tompa\\mchain\\reg\\"
files = os.listdir(rootfolder)
files.sort()
from ConfigParser import ConfigParser	
import shutil
c = ConfigParser()
f = file("blocksindexes.conf")
c.readfp(f)
f.close()	

for f in files:
	if f.find(".res") == -1: continue
	print f
	print c.getint("length", f.split("_-_")[0])
	if not int(f.split("_-_")[3]) == c.getint("length", f.split("_-_")[0]):
		shutil.move(rootfolder+f, rootfolder+"rest\\"+f)

	

"""


