from random import choice, random, randint, sample
from time import clock

SYMBOLS = "acgt"
CHANGE = {"a":"cgt", "c":"agt", "g":"act", "t":"acg"}


def genSequence(length=1000):
	r = range(length)
	for i in range(length): r[i] = choice(SYMBOLS)
	return r
	
def mutate_n_pos(input, n=4):
	assert(len(input) > n)
	input = list(input)
	
	mutatePos = sample(xrange(len(input)), n)
	
	for p in mutatePos:	input[p] = choice(CHANGE[input[p]])
		
	return input

def mutate_with_probability(input, prob=4./15):
	input = list(input)
	for i in range(len(input)):
		if random() < prob: input[i] = choice(CHANGE[input[i]])

	return input
	
def genSequenceWithInput(input, length = 1000):
	input = list(input)
	seq = genSequence(length)
	pos = randint(0, length-len(input))
	seq[pos:pos+len(input)] = input
	
	return seq, pos

def createDataset(numseq, seqlen, mlen, seq_without_m = 0, mf = mutate_n_pos):
	nmindex = sample(xrange(numseq), seq_without_m)
	
	output = []
	consensus = genSequence(mlen)
	
	print consensus
	seq, pos, mot = None, None, None
	for i in range(numseq):
		
		if i in nmindex:
			seq = genSequence(seqlen)
			pos = -1
			mot = [" "]
		else:
			mot = mf(consensus)
			seq, pos = genSequenceWithInput(mot, seqlen)
			
		
		output.append(">Sequence %s, %s, %s, %s" % (i, pos, "".join(consensus), "".join(mot)))
		output.append("".join(seq))
		output.append("")
	return "\n".join(output)




if __name__ == '__main__':
	PATH = "../../shared/md_datasett/dataset/dna/synthetic/x_mutations/syn-"
	for i in range(1, 11):
		fp = file(PATH + ("%03d"%i) + ".fasta", "w")

		fp.write(createDataset(20, 600, 15, 0, mutate_with_probability))
		fp.close()
	
	
