import os

#absolute paths in case main.py is run from another folder
RESULTFOLDER = os.path.abspath(os.path.split(__file__)[0]) + os.sep+"results"+os.sep+"dip"+os.sep+"res"+os.sep
OBJECTFOLDER = os.path.abspath(os.path.split(__file__)[0]) + os.sep+"results"+os.sep+"dip"+os.sep+"obj"+os.sep
SPLIT = "_-_"

import pickle

class Result:
	def __init__(self, motif=None, testType=None):
		self.m = motif
		self.tt = testType
		
	def __str__(self):
		r = "Result:\n"
		
		for name, value in vars(self).iteritems():
			r += name + " " +str(value)+ "\n"
		return r
		
	def write(self,filename=None):
		if filename == None:
			
			#filename = self.m.dataset._filename+SPLIT+self.tt+SPLIT+self.m.id+SPLIT+str(self.m.length)+SPLIT+self.m.scoringFunction+".res"
			filename = self.m.dataset._filename+SPLIT+self.tt+SPLIT+self.m.id+SPLIT+'%(l)02d'%{'l':self.m.length}+SPLIT+self.m.scoringFunction+".res"
		
		filename = OBJECTFOLDER + filename
		
		f = file(filename, "w")
		pickle.dump(self, f)
		f.close()
	
	def read(self,filename=None):

		filename = OBJECTFOLDER + filename
		
		f = file(filename)
		obj = pickle.load(f)
		self.m = obj.m
		self.tt = obj.tt
		f.close()
	

if __name__ == '__main__':
	subd = OBJECTFOLDER + "final_alg_mchain/"
	print subd
	files = os.listdir(subd)
	files.sort()
	import re
	pattern = re.compile(".+hdi.+")
	r = Result()
	
	
	for f in files:
		
		if not pattern.match(f):continue
		r.read("final_alg_mchain/"+f)
		#print r.m.dataset._filename
		#print r.m.TP, "\t", r.m.FN, "\t",r.m.FP,"\t", r.m.TN,"\t", r.m.score
		print r.m
	
	
	
	"""
	
	import sys
	import GraphGen as g
	r = Result()
	#subf = "added\\tba\\TRANSFAC\\"
	subf = "nytransfac\\a\\"
	rootfolder = OBJECTFOLDER+subf
	dirs = os.listdir(rootfolder)
	dirs.sort()
	hd, re, pw = {}, {}, {}
	
	avg = []
	totnum = 0
	det_info = {}
	for f in dirs:
		
		
		r.read(subf + f)
		
		
		
		if f.find("hdi") != -1: hd[f[:10]] = r.m.score
		elif f.find("reg") != -1: re[f[:10]] = r.m.score
		elif f.find("pwm") != -1:
			pw[f[:10]] = r.m.score
			


			seqcount = len(r.m.dataset._sequence_list)
			sitecount = r.m.TP + r.m.FN
			totbase = 0
			for line in r.m.dataset._sequence_list: totbase += len(line.seq)
			det_info[f[:10]] = (seqcount, sitecount, totbase, r.m.score)
		
			avg.append(r.m.score)
			if r.m.score == 1: totnum += 1
	avg = float(sum(avg))/len(avg)


		
	
	subf = "nytransfac\\b\\"
	rootfolder = OBJECTFOLDER+subf
	dirs = os.listdir(rootfolder)
	dirs.sort()
	hd2, re2, pw2 = {}, {}, {}
		
	avg2 = []
	totnum2 = 0
	det_info2 = {}	
	for f in dirs:
		
		
		r.read(subf + f)
		
		
		if f.find("hdi") != -1: hd2[f[:10]] = r.m.score
		elif f.find("reg") != -1: re2[f[:10]] = r.m.score
		elif f.find("pwm") != -1:
			pw2[f[:10]] = r.m.score
			seqcount = len(r.m.dataset._sequence_list)
			sitecount = r.m.TP + r.m.FN
			totbase2 = 0
			for line in r.m.dataset._sequence_list: totbase2 += len(line.seq)
			det_info2[f[:10]] = (seqcount, sitecount, totbase2, r.m.score)
		
			avg2.append(r.m.score)
			if r.m.score == 1: totnum2 += 1
	avg2 = float(sum(avg2))/len(avg2)
	
	subf = "nytransfac\\c\\"
	rootfolder = OBJECTFOLDER+subf
	dirs = os.listdir(rootfolder)
	dirs.sort()
	hd3, re3, pw3 = {}, {}, {}
	
	
	avg3 = []
	totnum3 = 0
	det_info3 = {}
		
	for f in dirs:
		
		
		r.read(subf + f)
		
		
		if f.find("hdi") != -1: hd3[f[:10]] = r.m.score
		elif f.find("reg") != -1: re3[f[:10]] = r.m.score
		elif f.find("pwm") != -1: 
			pw3[f[:10]] = r.m.score
			seqcount = len(r.m.dataset._sequence_list)
			sitecount = r.m.TP + r.m.FN
			totbase3 = 0
			for line in r.m.dataset._sequence_list: totbase3 += len(line.seq)
			det_info3[f[:10]] = (seqcount, sitecount, totbase3, r.m.score)
		
			avg3.append(r.m.score)
			if r.m.score == 1: totnum3 += 1
	avg3 = float(sum(avg3))/len(avg3)
	
	
	subf = "nytransfac\\d\\"
	rootfolder = OBJECTFOLDER+subf
	dirs = os.listdir(rootfolder)
	dirs.sort()
	hd4, re4, pw4 = {}, {}, {}
		
	avg4 = []
	totnum4 = 0
	det_info4 = {}	
	for f in dirs:
		
		
		r.read(subf + f)
		
		
		if f.find("hdi") != -1: hd4[f[:10]] = r.m.score
		elif f.find("reg") != -1: re4[f[:10]] = r.m.score
		elif f.find("pwm") != -1:
			pw4[f[:10]] = r.m.score
			seqcount = len(r.m.dataset._sequence_list)
			sitecount = r.m.TP + r.m.FN
			totbase4 = 0
			for line in r.m.dataset._sequence_list: totbase4 += len(line.seq)
			det_info4[f[:10]] = (seqcount, sitecount, totbase4, r.m.score)
		
			avg4.append(r.m.score)
			if r.m.score == 1: totnum4 += 1
	avg4 = float(sum(avg4))/len(avg4)
	#print len(hd), len(re), len(pw)
	#k = hd.keys()
	#k.sort()
	#tompa
	
	
	
	
	#END TOMPA
	
	
	
	temp = []
	for key, value in  pw.iteritems():
		temp.append((value, key))
	temp.sort()
	k = []
	for a, b in temp:
		k.append(b)
	temp = []
	for key, value in  pw2.iteritems():
		temp.append((value, key))
	temp.sort()
	k2 = []
	for a, b in temp:
		k2.append(b)
	temp = []
	for key, value in  pw3.iteritems():
		temp.append((value, key))
	temp.sort()
	k3 = []
	for a, b in temp:
		k3.append(b)
	temp = []
	for key, value in pw4.iteritems():
		temp.append((value, key))
	temp.sort()
	k4 = []
	for a, b in temp:
		k4.append(b)
	
	#print b + ",",
	#print k
	
	#print avg, avg2, avg3, avg4
	#print totnum, totnum2, totnum3, totnum4
	html = ["<html><body>"]
	html += ["<table><tr><td></td><th colspan=4>a</th><th colspan=4ba</th><th colspan=4>c</th><th colspan=4>d</th></tr>"]
	html += ["<tr><th>Average CC</th>"+"<td colspan=4>"+str(avg)+"</td>"+"<td colspan=4>"+str(avg2)+"</td>"+"<td colspan=4>"+str(avg3)+"</td>"+"<td colspan=4>"+str(avg4)+"</td></tr>"]
	html += ["<tr><th>Number of datasets where PWM CC=1</th>"+"<td colspan=4>"+str(totnum)+"</td>"+"<td colspan=4>"+str(totnum2)+"</td>"+"<td colspan=4>"+str(totnum3)+"</td>"+"<td colspan=4>"+str(totnum4)+"</td></tr>"]
	html += ["<tr><td></td>"+"<td>Sequence count</td><td>Site count</td><td>total number of bases</td><td>PWM score</td>"+\
	"<td>Sequence count</td><td>Site count</td><td>total number of bases</td><td>PWM score</td>"+\
	"<td>Sequence count</td><td>Site count</td><td>total number of bases</td><td>PWM score</td>"+\
	"<td>Sequence count</td><td>Site count</td><td>total number of bases</td><td>PWM score</td></tr>"]
	for key in k:
		html += ["<tr><th>"+key+"</th>"+"<td>"+str(det_info[key][0])+"</td>"+"<td>"+str(det_info[key][1])+"</td>"+"<td>"+str(det_info[key][2])+"</td>"+"<td>"+str(det_info[key][3])+"</td>"
		"<td>"+str(det_info2[key][0])+"</td>"+"<td>"+str(det_info2[key][1])+"</td>"+"<td>"+str(det_info2[key][2])+"</td>"+"<td>"+str(det_info2[key][3])+"</td>"+\
		"<td>"+str(det_info3[key][0])+"</td>"+"<td>"+str(det_info3[key][1])+"</td>"+"<td>"+str(det_info3[key][2])+"</td>"+"<td>"+str(det_info3[key][3])+"</td>"+\
		"<td>"+str(det_info4[key][0])+"</td>"+"<td>"+str(det_info4[key][1])+"</td>"+"<td>"+str(det_info4[key][2])+"</td>"+"<td>"+str(det_info4[key][3])+"</td></tr>"]
		
	html += ["</body></html>"]
	fp = file("c:\\summary.html", "w")
	fp.write("\n".join(html))
	fp.close()
	
	axis = [0, len(k)+10, 0, 1.1]
	title = "TRANSFAC_CC"
	xvalues = range(len(k))
	#hdy, rey, pwy = [], [], []
	pwy, pwy2, pwy3, pwy4 = [], [], [], []

	for key in k:
		pwy.append(pw[key])
	
	for key in k2:
		pwy2.append(pw2[key])
	for key in k3:	
		pwy3.append(pw3[key])
	for key in k4:
		pwy4.append(pw4[key])
		
	tompay = [0.137233597609, 0.199259924955, 0.240895659332, 0.354044616179, 0.403558286734, 0.403990711415, 0.41672075946, 0.461609002961, 0.492213963286, 0.534329564165, 0.539204613329, 0.546934163165, 0.568568921679, 0.570625466088, 0.595003252043, 0.628006365927, 0.630955624689, 0.666457253542, 0.667525098864, 0.670089856892, 0.673517358631, 0.6799609256, 0.680035735976, 0.687162527174, 0.706550196486, 0.706750645792, 0.712932534313, 0.714060843586, 0.718712322483, 0.720413282364, 0.721177350766, 0.737607279108, 0.755838680241, 0.763320797052, 0.769413062332, 0.798974358974, 0.798974358974, 0.821455256111, 0.865847702869, 0.8941233258, 0.899814126394, 0.935257437467, 1, 1, 1, 1, 1, 1, 1, 1]
	t = []
	for i in range (len(pwy)-len(tompay)): t.append(0)

	tompay = t + tompay
	input = []
	
	input.append({'x':xvalues, 'y':pwy, 'type':g.SPLINE,\
					'lineproperties':{'label':'a', 'marker':'o', 'linewidth':2, 'color':'b',\
					'markerfacecolor':'b'}})
	input.append({'x':xvalues, 'y':pwy2, 'type':g.SPLINE,\
					'lineproperties':{'label':'b', 'marker':'o', 'linewidth':2, 'color':'y',\
					'markerfacecolor':'y'}})
	input.append({'x':xvalues, 'y':pwy3, 'type':g.SPLINE,\
					'lineproperties':{'label':'c', 'marker':'o', 'linewidth':2, 'color':'r',\
					'markerfacecolor':'r'}})
	input.append({'x':xvalues, 'y':pwy4, 'type':g.SPLINE,\
					'lineproperties':{'label':'d', 'marker':'o', 'linewidth':2, 'color':'g',\
					'markerfacecolor':'g'}})
	input.append({'x':xvalues, 'y':tompay, 'type':g.SPLINE,\
					'lineproperties':{'label':'TOMPA', 'marker':'o', 'linewidth':2, 'color':'k',\
					'markerfacecolor':'k'}})
	
	#input.append({'x':xvalues, 'y':rey, 'type':g.SPLINE,\
	#				'lineproperties':{'label':'IUPAC', 'marker':'o', 'linewidth':2, 'color':'y',\
	#				'markerfacecolor':'y'}})
	#input.append({'x':xvalues, 'y':pwy, 'type':g.SPLINE,\
	#				'lineproperties':{'label':'PWM', 'marker':'o', 'linewidth':2, 'color':'r',\
	#				'markerfacecolor':'r'}})
	
	g.simplePlot(input, axis=axis, title=title, xlabel="datasets", ylabel="CC", fname="C:\\temp\\*")
	
	
	"""
		
