from Result import Result, OBJECTFOLDER, RESULTFOLDER
from ExtractMeme import extractInfo as memeInfo
import os, re
#Converts a Result.py result-file to new format (0-indexed to 1-indexed)
#"i" is the name of the result-file to convert
#"o" is output-filename
def resToStd(i, o):
	r = Result()
	r.read(i)
	
	odir, ofile = os.path.split(o)
	if odir == "" : odir="."
	if ofile == "" : ofile = i + ".txt"
	if not os.path.exists(odir): os.makedirs(odir)
	sequences = r.m.dataset.getSequences()
	length = r.m.length
	of = file(odir + os.sep + ofile, "w")
	r.m.hitlist
	
	for seqind, pos in r.m.hitlist:
		of.write(", ".join([r.m.dataset._sequence_list[seqind].id, repr(pos+1), repr(pos+length), sequences[seqind][pos:pos+length]])+"\n")
	of.close()
	
def batchResToStd(inputfolder, outputfolder, pattern):
	if not inputfolder[-1] in ("/", "\\", os.sep): inputfolder += os.sep
	if not outputfolder[-1] in ("/", "\\", os.sep): outputfolder += os.sep
	
	pattern = re.compile(pattern)
	inp = inputfolder
	if inp.find(OBJECTFOLDER) == 0: inp = inputfolder[len(OBJECTFOLDER):]
	for f in os.listdir(inputfolder):
		if not pattern.match(f): continue
		
		resToStd(inp+f, outputfolder+f.split("_")[0]+"_result.txt")
		
	

def memeToStd(i, o):
	print os.path.basename(i)
	res = memeInfo(i)
	
	odir, ofile = os.path.split(o)
	if odir == "" : odir="."
	if ofile == "" : ofile = i + ".txt"
	if not os.path.exists(odir): os.makedirs(odir)
	of = file(odir + os.sep + ofile, "w")
	for k in res:
		for d in res[k]:
			of.write(", ".join([k, repr(d["pos"]+1), repr(d["pos"]+len(d["motif"])), d["motif"].lower()]) + "\n")
	of.close()

def batchMemeToStd(inputfolder, outputfolder, pattern):
	if not inputfolder[-1] in ("/", "\\", os.sep): inputfolder += os.sep
	if not outputfolder[-1] in ("/", "\\", os.sep): outputfolder += os.sep
	
	pattern = re.compile(pattern)
	for f in os.listdir(inputfolder):
		if not pattern.match(f): continue
		memeToStd(inputfolder+f, outputfolder+f.split(".")[0]+"_result.txt")
	
	
if __name__ == "__main__":
	#batchResToStd(OBJECTFOLDER,\
	#			RESULTFOLDER, ".+MARKOV.+reg.+")
	batchMemeToStd(r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\final\final_memeresults\raw\rem_r",\
	r"C:\Diplom\Prosjekt\framework\trunk\shared\md_datasett\dataset\dna\final\final_memeresults\converted\rem_r", ".+txt$")
	