import sys
from library.motif.motif import motif_pwm
from system import data

def read_pwm(filename):
    if _jaspar():
        pareto = _read_jaspar(filename)
    elif _transfac():
        pareto = _read_transfak(filename)
    else:
        return
    if data.seqfile:
        _generate_hitlist(pareto)
    
    return pareto

def _jaspar():
    return 1

def _transfac():
    return 0

def _read_jaspar(filename):

    file = open(filename, 'r')
    line = file.readline()
    reading_pwm = 0
    pareto = []
    alignment_matrix = []
    
    while line:
        if line[0] == '#' or line[0] == '\n':
            line = file.readline()
            continue
        if line[0] == '>':
            if alignment_matrix:
                motif = motif_pwm(name, alignment_matrix)
                pareto.append(motif) 
                alignment_matrix = []
            name = line[1:].strip()
            line = file.readline()
            continue
        weights = line.split()
        weights = map(int, weights)
        alignment_matrix.append(weights)
        line = file.readline()
    
    if alignment_matrix:
        motif = motif_pwm(name, alignment_matrix)
        pareto.append(motif)
                                
    return pareto
   
def _generate_hitlist(motifs):
    
    file = open(data.seqfile)
    line = file.readline()
    sequences = []
    i = 0
    j = 0
    
    while line:
        if line[0] == '#' or line[0] == '\n' or line[0] == '>':
            line = file.readline()
            continue
        else:
            if len(sequences) < 10:
                sequences.append(line.strip())
                line = file.readline()
                i += 1
                continue
            else:
                for f in motifs:
                    f.create_hits(j, sequences)
                sequences = [line]
                j += 10
                i += 0
                continue
    if sequences:
        for f in motifs:
            f.create_hits(j, sequences)