#import sys
from math import ceil

class md_statistics:
    def __init__(self):
        self.seq_len = []
        self.char_freq = {}
        self.num_motifs = 0
        self.ds_name = ""
    
    #convenience functions for users of the statistics object (functions that uses the class members to return additional statistics)
    def num_seqs(self):
	return len(self.seq_len)

    def avg_seq_length(self):
        if len(self.seq_len) == 0:
            return -1

        sum = 0
        for length in self.seq_len:
            sum += length
        return sum / len(self.seq_len)

    def print_labels(self):
	print "num_seqs\tavg_seqlen\tnum_motifs"

    def print_stat(self):
	print str(self.num_seqs()) + "\t" + str(self.avg_seq_length()) + "\t" + str(self.num_motifs)

    #convenience functions for creators of the statistics object (functions that assigns values to class members)

    #assign class members from sequences in fasta format
    def parse_fasta(self, filename):
        file = open(filename, 'r')

        number = {}
        total = 0.0
        max_support = 0
        
        line = file.readline()
        while line:
            if line[0] == '#' or line[0] == '\n':
                line = file.readline()
                continue
            if line[0] == '>':
                line = file.readline()
                continue
            line = line.strip()
            self.seq_len.append( len(line) )
            for j in line:
                if number.has_key(j):
                    number[j] = number[j] + 1.0
                    total = total + 1.0
                else:
                    number[j] = 1.0
                    total = total + 1.0
            line = file.readline()

        self.char_freq = {}
        for f in number.keys():
            self.char_freq[f] = number[f] / total
        file.close()        
        return

    #Possible to use, but will be slow if motif file is big. Number of motifs could then instead be hardcoded in read.py.
    def parse_teiresias(self,filename):
        file = open(filename, 'r')
        line = file.readline()
        count = 0
        while line:
            count += 1
            line = file.readline()
        return count
    
