
from copy import copy
from library.pwm import pwm

#Kva navnekonvensjon skal vi ha? setSign.. eller set_sign...
class motif:
    
    def __init__(self):
        self._significance = 0
        self._support = -1
        self._pattern = []
        self._hitlist = {}
        
    def __str__(self):
        return "{pattern: " + str(self._pattern) +\
            ",\tsignificance: " + str(self._significance) +\
            ",\tsupport: " + str(self._support) +\
            "}"

    def set_significance(self, num):
        self._significance = num

    def get_significance(self):
        return self._significance

    def set_support(self, supp):
        self._support = supp
    
    def get_support(self):
        return self._support

    def set_bitset(self, bitset):
        self._bitset = bitset

    def get_bitset(self):
        return self._bitset

    def set_pattern(self, pattern):
        self._pattern = pattern

    def get_pattern(self):
        return self._pattern
    
    def set_hitlist(self, hitlist):
        self._hitlist = hitlist

    def get_hitlist(self):
        return self._hitlist
    
    def add_hitlist_entry(self, segment, position, length):
        if not self._hitlist.has_key(segment):
            self._hitlist[segment] = {}
        self._hitlist[segment][position] = length
    
    def get_motif_positions(self):
        r = []
        for seqID in self._hitlist:
            for position in self._hitlist[seqID]:
                r.append((seqID, position))
        return r
    
    def set_hitlist(self, list, length=None):
        self._hitlist = {}
        if length ==None:
            for line in list:
                if not self._hitlist.has_key(line[0]):
                    self._hitlist[line[0]] = {}
                self._hitlist[line[0]][line[1]] = line[2]
        else:
            for line in list:
                if not self._hitlist.has_key(line[0]):
                    self._hitlist[line[0]] = {}
                self._hitlist[line[0]][line[1]] = length
    
    def get_hitlist(self):
        return self._hitlist
    
    def get_motif_windows(self):
        r = []
        for seqID in self._hitlist:
            for position, length in self._hitlist[seqID].iteritems():
                r.append((seqID, position, length))
        return r
    
    
class motif_known(motif):
    def __init__(self):
        motif.__init__(self)
        self._instance_list = []
    def __str__(self):
        r = motif.__str__(self)+"\n\n"
        r += "Instances: "
        for line in self._instance_list:
            r+= line + ", "
        r+="\n\nHitlist: "+str(self._hitlist)
        return r
       
            
    

class motif_regexp(motif):
    
    def __init__(self):
        motif.__init__(self)
        self._total_hits = -1
        
        
    def set_total_hits(self, hits):
        self._total_hits = hits

    def get_total_hits(self):
        return self._total_hits
    
class motif_pwm(motif):


    def __init__(self, name, alignment):
        motif.__init__(self)
        self._pwm = pwm(name, alignment)
        
    def get_name(self):
        return self._pwm.get_name()

    def get_num_samples(self):
        return self._pwm.get_num_samples()

    def get_length(self):
        return self._pwm.len()

    def get_pattern(self):
        return self._pwm.get_pattern()

    def get_alignment_matrix(self):
        return self._pwm.get_alignment()

    def get_pwm_matrix(self):
        return self._pwm.get_pwm_matrix()

    def get_hitlist(self):
        return self._pwm.get_hits()

    def create_hits(self, startindex, sequences):
        self._pwm.create_hits(startindex, sequences)
    
        
class motif_composite(motif):

    def __init__(self):
        motif.__init__(self)
        self._last_significance = 0
        self._num_components = 0

    def get_last_sign(self):
        return self._last_significance

    def get_num_components(self):
        return self._num_components

    def add(self, motif):
        self._last_significance = motif.get_significance()
        self._significance += motif.get_significance()
        for f in motif.get_pattern():
            self._pattern.append(f)
        if self._num_components > 0:
            c = self._bitset.copy()
            c.AND(motif.get_bitset())
            self.set_bitset(c)
        else:
            self._bitset = motif.get_bitset()
        self._support = self._bitset.count()
        self._num_components += 1

    def __str__(self):
        return "{pattern: " + str(self._pattern) +\
            ",\thits: " + self._bitset.__str__() +\
            ",\tsignificance: " + str(self._significance) +\
            ",\tsupport: " + str(self._support) +\
            ",\tnum_components: " + str(self._num_components) +\
            "}"

    
    def copy(self):
        """ this is not used as of yet """
        a = copy(self)
        a._num_components =  copy(self._num_components)
        a.set_bitset(self._bitset.copy()) 
        
        return a

