from system import data, conf
from math import pow
from math import log


def log2(num):
	return log(num,2)


def significance(pattern):

    sign = 1.0
    logsign = 0.0
    ambsign = 1.0
    length = 0
    inamb = 0

    for char in pattern:
        if not inamb:
            if data.freq.has_key(char):
                logsign += log2(data.freq[char])
                sign *= data.freq[char]
                length += 1

            elif char == '[':
                ambsign = 0.0
                inamb = 1
                continue
        elif data.freq.has_key(char):
            ambsign += data.freq[char]

        elif char == ']':
            sign *= ambsign
            logsign += log2(ambsign)
            length += 1
            inamb = 0

        else:
            print "unknown symbol in pattern"

    if length >= data.avg_seq_length:
        return (-1)*logsign
    elif logsign < -40:
        return (-1)*(logsign + log2(data.avg_seq_length - length))
    else:
        return (-1)*(log2(1.0 - pow(1.0 - sign, data.avg_seq_length - length)))