import os
from library.motif.motif import motif_known
from library.dataset import dataset
from library.md_statistics import md_statistics
from library.sequence import sequence

FMO001 = 0
FMO002 = 1
FMO003 = 2
FMO004 = 3
FMO005 = 4
FMO006 = 5
FMO007 = 6
FMO008 = 7
FMO009 = 8
FMO010 = 9



#All sets
SETS = {FMO001:"fmo-001.fasta", FMO002:"fmo-002.fasta", FMO003:"fmo-003.fasta", FMO004:"fmo-004.fasta",\
	FMO005:"fmo-005.fasta", FMO006:"fmo-006.fasta", FMO007:"fmo-007.fasta", FMO008:"fmo-008.fasta",\
		FMO009:"fmo-009.fasta", FMO010:"fmo-010.fasta"}



def getDataset(variant = FMO001):

	filename = ""
	
	try:
		
		if variant in SETS.values():
			
			filename = variant
		else:
			
			filename = SETS[variant]
	except:
		
		print "Error in synthetic.x_mutations.read.getDataset: parameter not valid"
		return
	
	ds = dataset()
	ds._ID = "SYNTHETIC_F_MUTATIONS"
	ds._filename = filename
	ds._description = "Synthetic dataset with 20 sequences, all 600bp long"
	ds.parse_synthetic(get_path_file(filename))
	return ds

def get_statistics():
	stat = md_statistics()
	stat.parse_fasta( get_path_file("genes_data") )
	stat.name = "CREB_data"
	return stat

def get_path_file(filename):
	#Gets the path that the python file itself is in, which is the same path that the data files will be in. 
	path = os.path.abspath(os.path.split(__file__)[0]) + os.sep
	return path + filename

