import os
from library.motif.motif import motif_known
from library.dataset import dataset
from library.md_statistics import md_statistics
from library.sequence import sequence

FMZ001 = 0
FMZ002 = 1
FMZ003 = 2
FMZ004 = 3
FMZ005 = 4
FMZ006 = 5
FMZ007 = 6
FMZ008 = 7
FMZ009 = 8
FMZ010 = 9



#All sets
SETS = {FMZ001:"fmz-001.fasta", FMZ002:"fmz-002.fasta", FMZ003:"fmz-003.fasta", FMZ004:"fmz-004.fasta",\
	FMZ005:"fmz-005.fasta", FMZ006:"fmz-006.fasta", FMZ007:"fmz-007.fasta", FMZ008:"fmz-008.fasta",\
		FMZ009:"fmz-009.fasta", FMZ010:"fmz-010.fasta"}



def getDataset(variant = FMZ001):

	filename = ""
	
	try:
		
		if variant in SETS.values():
			
			filename = variant
		else:
			
			filename = SETS[variant]
	except:
		
		print "Error in synthetic.x_mutations.read.getDataset: parameter not valid"
		return
	
	ds = dataset()
	ds._ID = "SYNTHETIC_FZOOPS_MUTATIONS"
	ds._filename = filename
	ds._description = "Synthetic dataset with 20 sequences, all 600bp long"
	ds.parse_synthetic(get_path_file(filename))
	return ds

def get_statistics():
	stat = md_statistics()
	stat.parse_fasta( get_path_file("genes_data") )
	stat.name = "CREB_data"
	return stat

def get_path_file(filename):
	#Gets the path that the python file itself is in, which is the same path that the data files will be in. 
	path = os.path.abspath(os.path.split(__file__)[0]) + os.sep
	return path + filename

