import os
from library.motif.motif import motif_known
from library.dataset import dataset
from library.md_statistics import md_statistics
from library.sequence import sequence

SYN001 = 0
SYN002 = 1
SYN003 = 2
SYN004 = 3
SYN005 = 4
SYN006 = 5
SYN007 = 6
SYN008 = 7
SYN009 = 8
SYN010 = 9



#All sets
SETS = {SYN001:"syn-001.fasta", SYN002:"syn-002.fasta", SYN003:"syn-003.fasta", SYN004:"syn-004.fasta",\
	SYN005:"syn-005.fasta", SYN006:"syn-006.fasta", SYN007:"syn-007.fasta", SYN008:"syn-008.fasta",\
		SYN009:"syn-009.fasta", SYN010:"syn-010.fasta"}



def getDataset(variant = SYN001):

	filename = ""
	
	try:
		
		if variant in SETS.values():
			
			filename = variant
		else:
			
			filename = SETS[variant]
	except:
		
		print "Error in synthetic.x_mutations.read.getDataset: parameter not valid"
		return
	
	ds = dataset()
	ds._ID = "SYNTHETIC_X_MUTATIONS"
	ds._filename = filename
	ds._description = "Synthetic dataset with 20 sequences, all 600bp long"
	ds.parse_synthetic(get_path_file(filename))
	return ds

def get_statistics():
	stat = md_statistics()
	stat.parse_fasta( get_path_file("genes_data") )
	stat.name = "CREB_data"
	return stat

def get_path_file(filename):
	#Gets the path that the python file itself is in, which is the same path that the data files will be in. 
	path = os.path.abspath(os.path.split(__file__)[0]) + os.sep
	return path + filename

