import os

from library.motif.motif import motif_known
from library.dataset import dataset
from library.md_statistics import md_statistics
from library.sequence import sequence

	
M00724 = 0
M00762 = 1
M00770 = 2
M00789 = 3
M00791 = 4
M00795 = 5
M00801 = 6
M00806 = 7
M00912 = 8
M00924 = 9
M00925 = 10
M00926 = 11
M00931 = 12
M00932 = 13
M00933 = 14
M00959 = 15
M00963 = 16
M00964 = 17
M00971 = 18
M00972 = 19
M00976 = 20
M00981 = 21
M01032 = 22
M01033 = 23
M01034 = 24



#All sets
SETS = {M00724: "M00724.fas",  M00762: "M00762.fas",  M00770: "M00770.fas",  M00789: "M00789.fas",\
		M00791: "M00791.fas",  M00795: "M00795.fas",  M00801: "M00801.fas",  M00806: "M00806.fas",\
		M00912: "M00912.fas",  M00924: "M00924.fas",  M00925: "M00925.fas",  M00926: "M00926.fas",\
		M00931: "M00931.fas",  M00932: "M00932.fas",  M00933: "M00933.fas",  M00959: "M00959.fas",\
		M00963: "M00963.fas",  M00964: "M00964.fas",  M00971: "M00971.fas",  M00972: "M00972.fas",\
		M00976: "M00976.fas",  M00981: "M00981.fas",  M01032: "M01032.fas",  M01033: "M01033.fas",\
		M01034: "M01034.fas"}
		
print len(SETS)


def getDataset(variant = M00724):

	filename = ""
	
	try:
		
		if variant in SETS.values():
			
			filename = variant
		else:
			
			filename = SETS[variant]
	except:
		
		print "Error in NYMCHAIN.read.getDataset: parameter not valid"
		return
	
	ds = dataset()
	ds._ID = "NEW_MARKOV_CHAIN"
	ds._filename = filename
	ds._description = "New markov chain sets"
	ds.parse_final(get_path_file(filename))
	return ds

def get_statistics():
	stat = md_statistics()
	stat.parse_fasta( get_path_file("genes_data") )
	stat.name = "CREB_data"
	return stat

def get_path_file(filename):
	#Gets the path that the python file itself is in, which is the same path that the data files will be in. 
	path = os.path.abspath(os.path.split(__file__)[0]) + os.sep
	return path + filename

